<?php
/* tabstop=4 tabreplace=space */
/**
 * Joomla-SMF Forum
 *
 * This file is the html templateused for the backend installation
 * and configuration that is accessed via
 * Components->Joomla-SMF Forum->Configuration
 *
 * LICENSE: This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 * @category    Component
 * @package     com_smf
 * @author      Cowboy <ross@joomlahacks.com>
 * @author      Wolverine <joshualross@gmail.com>
 * @copyright   (C) JoomlaHacks.com. All rights reserved.
 * @license     http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @version     $Id: admin.smf.html.php 296 2006-11-11 21:31:01Z joshualross $
 * @revision    $LastChangedRevision: 296 $
 * @date        $LastChangedDate: 2006-11-11 16:31:01 -0500 (Sat, 11 Nov 2006) $
 * @file        $HeadURL: http://scm.joomla.org/svn/repos/joomla-smf_2_0/admin.smf.html.php $
 * @link        http://www.JoomlaHacks.com
 * @link        http://www.joshualross.us
 * @since       File available since Release 2.0
 *
 * Visit JoomlaHacks.com for more Joomla Hacks!
 */

// no direct access
defined( '_VALID_MOS' ) or die( 'Restricted access' );
if (!defined('JSMFADMIN_BASE')) {
    /** #@+
     * Constants
     */
    /**
     * JSMFADMIN_BASE
     */
    define('JSMFADMIN_BASE', dirname(__FILE__));
    /** #@- */
}

/**
 * Joomla-SMF administration display
 * @package com_smf
 */
class jsmfAdminHTML {





    /**
     * Display the Joomla-SMF Configuration tab
     *
     *
     * @access public
     * @param object reference $jsmfConfig Joomla-SMF configurations
     * @param object reference $jsmfAdmin Joomla-SMF Adminisration functions
     * @return boolean
     */
    function showConfig(&$jsmfConfig, &$jsmfAdmin)
    {

        jsmfAdminHTML::__showHeader($jsmfConfig);
        ?>
        <input type="hidden" name="admin_menu_alt" value="<?php echo _JSMF_HEADER; ?>" />
        <input type="hidden" name="admin_menu_img" value="js/ThemeOffice/config.png" />
        <?php
        $tabs = new mosTabs(0);
        $tabs->startPane( 'configPane' );

        $tabs->startTab( _JSMF_TAB_CONFIGURATION_TITLE, 'config-page' );
        jsmfAdminHTML::__showConfigTab($jsmfConfig, $jsmfAdmin);
        $tabs->endTab();

        if ($jsmfAdmin->isComInstalled('Community Builder%')) {
            $tabs->startTab( _JSMF_TAB_CB_TITLE, 'cb-page' );
            jsmfAdminHTML::__showCBTab($jsmfConfig, $jsmfAdmin);
            $tabs->endTab();
        }
        if ($jsmfAdmin->isComInstalled('Joomap')) {
            $tabs->startTab( _JSMF_TAB_JOOMAP_TITLE, 'joomap-page' );
            jsmfAdminHTML::__showJoomapTab($jsmfConfig, $jsmfAdmin);
            $tabs->endTab();
        }


        $tabs->endPane();


        jsmfAdminHTML::__showFooter();

    }


    /**
     * Display the administration install screen
     * @param object reference $jsmfConfig Joomla-SMF configurations
     * @param object reference $jsmfAdmin Joomla-SMF Adminisration functions
     * @access public
     */
    function showInstall(&$jsmfConfig, &$jsmfAdmin)
    {

        jsmfAdminHTML::__showHeader($jsmfConfig);
        ?>
        <input type="hidden" name="admin_menu_alt" value="<?php echo _JSMF_HEADER; ?>" />
        <input type="hidden" name="admin_menu_img" value="js/ThemeOffice/install.png" />
        <?php
        $tabs = new mosTabs(0);
        $tabs->startPane( 'configPane' );

        $tabs->startTab( _JSMF_TAB_INSTALLATION_TITLE, 'install-page' );
        jsmfAdminHTML::__showInstallTab($jsmfConfig, $jsmfAdmin);
        $tabs->endTab();
        $tabs->startTab( _JSMF_TAB_REGISTRATION_TITLE, 'registration-page' );
        jsmfAdminHTML::__showRegistrationTab($jsmfConfig, $jsmfAdmin);
        $tabs->endTab();

        //$tabs->startTab( _JSMF_TAB_PERMISSION_TITLE, 'permission-page' );
        //jsmfAdminHTML::_showPermTab($jsmfConfig, $jsmfAdmin);
        //$tabs->endTab();

        $tabs->endPane();


        jsmfAdminHTML::__showFooter();

    }


    /**
     * Display the administration install screen
     *
     *
     * @access public
     * @param object reference $jsmfConfig Joomla-SMF configurations
     * @param object reference $jsmfAdmin Joomla-SMF Administration functions
     * @return n/a
     */
    function showGeneral(&$jsmfConfig, &$jsmfAdmin)
    {
        jsmfAdminHTML::__showHeader($jsmfConfig);
        ?>
        <input type="hidden" name="admin_menu_alt" value="<?php echo _JSMF_HEADER; ?>" />
        <input type="hidden" name="admin_menu_img" value="../administrator/components/com_smf/images/menu_logo.png" />
        <?php

        $smf_version = $jsmfAdmin->getSMFVersion();

        $tabs = new mosTabs(0);
        $tabs->startPane( 'configPane' );

        $tabs->startTab( _JSMF_TAB_GENERAL_TITLE, 'general-page' );
        jsmfAdminHTML::__showGeneralTab($jsmfConfig, $jsmfAdmin, $smf_version);
        $tabs->endTab();

        $tabs->startTab( _JSMF_TAB_HELP_TITLE, 'help-page' );
        jsmfAdminHTML::__showHelpTab($jsmfConfig, $jsmfAdmin, $smf_version);
        $tabs->endTab();

        $tabs->endPane();


        jsmfAdminHTML::__showFooter();

    }

    /**
     * Display error
     */
    function showError(&$error)
    {
    	global $jsmfConfig;
        jsmfAdminHTML::__showHeader($jsmfConfig);
        $tabs = new mosTabs(0);
        $tabs->startPane( 'configPane' );
        $tabs->startTab( _JSMF_TAB_ERROR_TITLE, 'general-page' );
        jsmfAdminHTML::__showErrorTab($error);
        $tabs->endTab();

        $tabs->endPane();

        jsmfAdminHTML::__showFooter();

    }


    /**
     * Display the Joomla Administration header
     *
     *
     * @access private
     * @param object $jsmfConfig Joomla-SMF configurations
     * @return n/a
     */
    function __showHeader($jsmfConfig)
    {
        global $mosConfig_live_site;
        $task = mosGetParam($_REQUEST, 'task', '');

        ?>
        <div id="overDiv" style="position:absolute; visibility:hidden; z-index:10000;"></div>

        <table class="adminheading">
            <tr>

                    <?php
                    switch ($task) {
                        case "install":
                            echo '<th class="install">';
                            echo _JSMF_HEADER_INSTALL;
                            echo '</th>';
                            break;
                        case "config":
                            echo '<th class="config">';
                            echo _JSMF_HEADER_CONFIG;
                            echo '</th>';
                            break;
                        default:
                            echo '<th style="background: url(components/com_smf/images/gen_logo.png) no-repeat left;">';
                            echo _JSMF_HEADER_GENERAL;
                            echo '</th>';
                            break;
                    }
                    ?>
            </tr>
        </table>
        <?php
        //display full messages if joomla cuts them off
        $msg =  mosGetParam($_REQUEST, 'mosmsg', '');
        if (strlen($msg) > 100) {
            ?>
        <table>
            <tr>
                <td>
                    <b><?php echo $msg;?></b>
                </td>
            </tr>
        </table>
            <?php   
        }
        ?>
        

        <script language="javascript" type="text/javascript">
            <!--
            function submitbutton(pressbutton) {
                var form = document.adminForm;
                submitform( pressbutton );
                return;
            }
            function isInteger(s)
            {
                var i;
                for (i = 0; i < s.value.length; i++)
                {
                    var c = s.value.charAt(i);
                    if (((c < "0") || (c > "9"))) {
                       s.value = s.value.replace(c, '');
                    }
                }
            }
            //-->
        </script>

        <form action="index2.php" method="post" name="adminForm">
            <script type="text/javascript" language="javascript" src="<?php echo $mosConfig_live_site;?>/includes/js/overlib_mini.js"></script>
            <input type="hidden" name="name" value="Joomla-SMF Forum" />
            <input type="hidden" name="admin_menu_link" value="option=com_smf" />
            <input type="hidden" name="option" value="<?php echo $jsmfConfig->option; ?>" />
            <input type="hidden" name="jsmfConfig[task]" value="<?php echo mosGetParam($_REQUEST, 'task', ''); ?>" />
            <input type="hidden" name="jsmfConfig[itemid]" value="<?php echo $jsmfConfig->itemid; ?>" />
            <input type="hidden" name="task" value="" />
            <input type="hidden" name="boxchecked" value="0" />
        <?php



    }

    /**
     * Display the Joomla-SMF Administration footer
     *
     *
     * @access private
     * @return n/a
     */
    function __showFooter()
    {


        ?>
        </form>
        <?php
    }


    /**
     * Display the installation tab
     *
     *
     * @access private
     * @param object reference $jsmfConfig Joomla-SMF configurations
     * @param object reference $jsmfAdmin Joomla-SMF Administration functions
     * @return n/a
     * @global string $mosConfig_absolute_path
     * @global string $mosConfig_live_site
     * @global object $jsmfPatch
     */
    function __showInstallTab(&$jsmfConfig, &$jsmfAdmin)
    {

        global $mosConfig_absolute_path, $mosConfig_live_site, $jsmfPatch;

        ?>
            <!-- INSTALL TAB -->
            <table width="100%" border="0" cellpadding="2" cellspacing="2">
                <tr>
                    <th style="vertical-align: top;" colspan="2" align="left">
                        <?php echo _JSMF_TAB_INSTALLATION_HEADER; ?>
                        <hr />
                    </th>
                </tr>
                <tr>

                    <td style="vertical-align: top;" width="60%">

                        <table width="100%" border="0" cellpadding="2" cellspacing="2" class="adminForm">
                            <tr>
                                <td align="right" style="vertical-align: top;" width="170">
                                    <?php echo mosToolTip(_JSMF_FIELD_FORUM_URL_HELP, _JSMF_FIELD_FORUM_URL, '', 'tooltip.png', _JSMF_FIELD_FORUM_URL); ?>
                                </td>
                                <td align="left" style="vertical-align: top;">
                                    <input type="text" name="jsmfConfig[url]" value="<?php echo $jsmfConfig->url; ?>" size="75" disabled="disabled" />
                                </td>
                            </tr>
                            <tr>
                                <td align="right" style="vertical-align: top;" width="170">
                                    <?php echo mosToolTip( _JSMF_FIELD_SMF_PATH_ABSOLUT_HELP, _JSMF_FIELD_SMF_PATH_ABSOLUT, '', 'tooltip.png', _JSMF_FIELD_SMF_PATH_ABSOLUT); ?>
                                </td>
                                <td align="left" style="vertical-align: top;">
                                    <input type="text" name="jsmfConfig[smf_path]" value="<?php if (!empty($jsmfConfig->smf_path)) { echo $jsmfConfig->smf_path; } else { echo $mosConfig_absolute_path._JSMF_TEXT_SMF_PATH_HERE; } ?>" size="75" />
                                    <?php
                                        if (!empty($jsmfConfig->smf_path) && !file_exists($jsmfConfig->smf_path."/Settings.php")) {
                                            echo "<br />".jsmfAdminHTML::paintRed(_JSMF_TEXT_INCORRECT_PATH);
                                        }
                                    ?>
                                </td>
                            </tr>
                            <tr>
                                <td align="right" style="vertical-align: top;">
                                    <?php echo mosToolTip( _JSMF_FIELD_SMF_DB_PREFIX_HELP, _JSMF_FIELD_SMF_DB_PREFIX, '', 'tooltip.png', _JSMF_FIELD_SMF_DB_PREFIX); ?>
                                </td>
                                <td align="left" style="vertical-align: top;">
                                    <input type="text" name="jsmfConfig[smf_prefix]" value="<?php echo $jsmfConfig->smf_prefix; ?>" />
                                    <?php
                                        if (!$jsmfAdmin->isValidDBPrefix($jsmfConfig->smf_prefix)) {
                                            echo "<br />".jsmfAdminHTML::paintRed(_JSMF_TEXT_INCORRECT_PREFIX);
                                        }
                                    ?>
                                </td>
                            </tr>
                            <tr>
                                <td align="right">
                                    <?php
                                        if ($jsmfAdmin->isValidDBPrefix($jsmfConfig->smf_prefix)) {
                                            echo jsmfAdminHTML::paintGreen(_JSMF_TEXT_INSTALLED);
                                        } else {
                                            echo jsmfAdminHTML::paintRed(_JSMF_TEXT_NOT_INSTALLED);
                                        }
                                    ?>
                                </td>
                                <td>
                                    <?php echo mosToolTip( _JSMF_TEXT_INSTALL_SMF_HELP, _JSMF_TEXT_INSTALL_SMF, '', 'tooltip.png', _JSMF_TEXT_INSTALL_SMF); ?>
                                </td>
                            </tr>
                            <tr>
                                <td align="right">
                                    <?php
                                        if (!empty($jsmfConfig->smf_path)) {
                                            if ($jsmfAdmin->isPatched(JPATH_BASE.'/index.php', $jsmfPatch->JOOMLAHACKS)) {
                                                echo jsmfAdminHTML::paintGreen(_JSMF_TEXT_DONE) . " [<b><a href=\"".$mosConfig_live_site."/administrator/index2.php?option=".$jsmfConfig->option."&amp;task=unpatch\">"._JSMF_TEXT_UNPATCH."</a></b>]";
                                            } else {
                                                echo "<b><a href=\"".$mosConfig_live_site."/administrator/index2.php?option=".$jsmfConfig->option."&amp;task=patch\">"._JSMF_TEXT_PATCH."</a></b>" ;
                                            }
                                        }
                                    ?>
                                </td>
                                <td>
                                    <?php echo mosToolTip(_JSMF_TEXT_PATCH_JOOMLA_HELP, _JSMF_TEXT_PATCH_JOOMLA, '', 'tooltip.png', _JSMF_TEXT_PATCH_JOOMLA); ?>
                                </td>
                            </tr>
                            <tr>
                                <td align="right">
                                    <?php
                                        if (!empty($jsmfConfig->smf_path)) {
                                            if ($jsmfAdmin->isPatched($jsmfConfig->smf_path.'/index.php', $jsmfPatch->JOOMLAHACKS) &&
                                                /*$jsmfAdmin->isPatched($jsmfConfig->smf_path.'/Sources/Subs-Post.php', $jsmfPatch->JOOMLAHACKS) &&*/
                                                /*$jsmfAdmin->isPatched($jsmfConfig->smf_path.'/Themes/default/xml_topic.js', $jsmfPatch->JOOMLAHACKS) &&*/
                                                $jsmfAdmin->isPatched($jsmfConfig->smf_path.'/Sources/Subs.php', $jsmfPatch->JOOMLAHACKS)) {
                                                echo jsmfAdminHTML::paintGreen(_JSMF_TEXT_DONE) . " [<b><a href=\"".$mosConfig_live_site."/administrator/index2.php?option=".$jsmfConfig->option."&amp;task=unpatchsmf\">"._JSMF_TEXT_UNPATCH."</a></b>]";
                                            } else {
                                                echo "<b><a href=\"".$mosConfig_live_site."/administrator/index2.php?option=".$jsmfConfig->option."&amp;task=patchsmf\">"._JSMF_TEXT_PATCH."</a></b>";
                                            }
                                        }
                                    ?>
                                </td>
                                <td>
                                    <?php echo mosToolTip(_JSMF_TEXT_PATCH_SMF_HELP, _JSMF_TEXT_PATCH_SMF, '', 'tooltip.png', _JSMF_TEXT_PATCH_SMF); ?>
                                </td>
                            </tr>

                            <tr>
                                <td align="right">
                                    <?php
                                        if ($_SESSION['sync']) {
                                            echo jsmfAdminHTML::paintGreen(_JSMF_TEXT_DONE) . " [<b><a href=\"".$mosConfig_live_site."/administrator/index2.php?option=com_smf&amp;task=sync\">"._JSMF_TEXT_VERIFY."</a></b>] ";
                                        } else {
                                            echo "<b><a href=\"".$mosConfig_live_site."/administrator/index2.php?option=com_smf&amp;task=sync&amp;type=realname\">"._JSMF_TEXT_SYNC_REALNAME."</a></b>";
                                            echo "<br />";
                                            echo "<b><a href=\"".$mosConfig_live_site."/administrator/index2.php?option=com_smf&amp;task=sync&amp;type=username\">"._JSMF_TEXT_SYNC_USERNAME."</a></b>";
                                        }
                                    ?>
                                </td>
                                <td>
                                    <?php echo mosToolTip(_JSMF_TEXT_SYNC_JOOMLA_SMF_HELP, _JSMF_TEXT_SYNC_JOOMLA_SMF,  '', 'tooltip.png', _JSMF_TEXT_SYNC_JOOMLA_SMF); ?>
                                </td>
                            </tr>
                        </table>
                    </td>

                </tr>
            </table>


            <?php

    }


    /**
     * Display registration tab
     *
     *
     * @access private
     * @param object reference $jsmfConfig Joomla-SMF configurations
     * @param object reference $jsmfAdmin Joomla-SMF Administration functions
     * @return n/a
     * @global string $mosConfig_live_site
     */
    function __showRegistrationTab(&$jsmfConfig, &$jsmfAdmin)
    {
        global $mosConfig_live_site;
        ?>
        <!-- REGISTRATION TAB-->
            <table width="100%" border="0" cellpadding="2" cellspacing="2">
                <tr>
                    <th style="vertical-align: top;" align="left" colspan="2">
                        <?php echo _JSMF_TAB_REGISTRATION_HEADER; ?>
                        <hr />
                    </th>
                </tr>
                <tr>
                    <td align="right" style="vertical-align: top;" width="170">
                        <?php echo mosToolTip(_JSMF_FIELD_FORUM_REG_HELP, _JSMF_FIELD_FORUM_REG, '', 'tooltip.png', _JSMF_FIELD_FORUM_REG); ?>
                    </td>
                    <td align="left" style="vertical-align: top;">
                        <input type="text" name="jsmfConfig[code]" value="<?php echo $jsmfConfig->code; ?>" size="145" />
                    </td>
                </tr>
                <tr>
                    <td align="right">
                        <?php echo mosToolTip(_JSMF_FIELD_FORUM_DONATION_HELP, _JSMF_FIELD_FORUM_DONATION, '', 'tooltip.png', _JSMF_FIELD_FORUM_DONATION); ?>
                    </td>
                    <td align="left">
                        </form> <!-- end the joomla form -->
                        <form action="https://www.paypal.com/cgi-bin/webscr" method="post">
                        <input type="hidden" name="cmd" value="_xclick" />
                        <input type="hidden" name="business" value="joshualross@gmail.com" />
                        <input type="hidden" name="undefined_quantity" value="0" />
                        <input type="hidden" name="item_name" value="Joomla-SMF Project Donation" />
                        <input type="hidden" name="item_number" value="Item 1" />
                        <input type="hidden" name="no_note" value="1" />
                        <input type="hidden" name="cn" value="Thank you for your donations!" />
                        <input type="hidden" name="currency_code" value="USD" />
                        <input type="hidden" name="lc" value="GB" />
                        <input type="hidden" name="return" value="" />
                        <input type="hidden" name="cancel_return" value="" />
                        <input type="image" class="" src="https://www.paypal.com/en_US/i/btn/x-click-but04.gif" name="submit" alt="Joomla-SMF Project Donation" title="Joomla-SMF Project Donation" />
                    </td>
                </tr>
                <tr>
                    <td align="right" style="vertical-align: top;">
                        <input type="hidden" name="on0" value="Copyright Removal Request" />
                        <label for="textremoval"><?php echo mosToolTip(_JSMF_FIELD_FORUM_DONATION_REMOVAL_HELP, _JSMF_FIELD_FORUM_DONATION_REMOVAL, '', 'tooltip.png', _JSMF_FIELD_FORUM_DONATION_REMOVAL); ?></label>
                    </td>
                    <td align="left" style="vertical-align: top;">
                        <input type="checkbox" name="os0" value="<?php echo $mosConfig_live_site;?>" id="textremoval" />
                    </td>
                </tr>
                <tr>
                    <td colspan="2">
                        <hr />
                    </td>
                </tr>
                <tr>
                    <td colspan="2">
                        <?php echo _JSMF_FORUM_DONATION_THANK_YOU; ?>
                    </td>
                </tr>
            </table>
        <?php
    }

    /**
     * Show Configuration Tab
     *
     *
     * @access private
     * @param object reference $jsmfConfig Joomla-SMF configurations
     * @param object reference $jsmfAdmin Joomla-SMF Administration functions
     * @return n/a
     */
    function __showConfigTab(&$jsmfConfig, &$jsmfAdmin)
    {
         ?>
            <!-- CONFIGURATION TAB -->
            <table width="100%" border="0" cellpadding="2" cellspacing="2">
                <tr>
                    <th style="vertical-align: top;" align="left" colspan="2">
                        <?php echo _JSMF_TAB_CONFIGURATION_HEADER; ?>
                        <hr />
                    </th>
                </tr>
                <tr>
                    <td align="left" style="vertical-align: top;">
                        <table border="0" cellpadding="2" cellspacing="2" class="adminForm">
                            <tr>
                                <td align="right" style="vertical-align: middle;">
                                    <?php echo mosToolTip(_JSMF_FIELD_INTEGRATION_WRAPPED_HELP, _JSMF_FIELD_INTEGRATION_WRAPPED, '', 'tooltip.png', _JSMF_FIELD_INTEGRATION_WRAPPED); ?>
                                </td>
                                <td align="left" style="vertical-align: middle;">
                                    <input type="radio" name="jsmfConfig[wrapped]" value="1" <?php echo strcasecmp($jsmfConfig->wrapped, 1) == 0 ? 'checked="checked"' : '' ; ?> id="wrapped1"/>
                                    <label for="wrapped1"><?php echo _JSMF_ENABLE; ?></label>
                                </td>
                                <td align="left" style="vertical-align: middle;">
                                    <input type="radio" name="jsmfConfig[wrapped]" value="0" <?php echo strcasecmp($jsmfConfig->wrapped, 0) == 0 ? 'checked="checked"' : '' ; ?> id="wrapped0"/>
                                    <label for="wrapped0"><?php echo _JSMF_DISABLE; ?></label>
                                </td>
                            </tr>
                            <tr>
                                <td align="right" style="vertical-align: middle;">
                                    <?php echo mosToolTip(_JSMF_FIELD_SYNC_USERNAMES_HELP, _JSMF_FIELD_SYNC_USERNAMES, '', 'tooltip.png', _JSMF_FIELD_SYNC_USERNAMES); ?>
                                </td>
                                <td align="left" style="vertical-align: middle;">
                                    <input type="radio" name="jsmfConfig[sync_uname]" value="1" <?php echo strcasecmp($jsmfConfig->sync_uname, 1) == 0  ? 'checked="checked"' : '' ; ?> id="sync_uname1" />
                                    <label for="sync_uname1"><?php echo _JSMF_ENABLE; ?></label>
                                </td>
                                <td align="left" style="vertical-align: middle;" colspan="2">
                                    <input type="radio" name="jsmfConfig[sync_uname]" value="0" <?php echo strcasecmp($jsmfConfig->sync_uname, 0) == 0 ? 'checked="checked"' : '' ; ?> id="sync_uname0" />
                                    <label for="sync_uname0"><?php echo _JSMF_DISABLE; ?></label>
                                </td>
                            </tr>
                            <tr>
                                <td align="right" style="vertical-align: middle;">
                                    <?php echo mosToolTip(_JSMF_FIELD_HIDE_EMAIL_HELP, _JSMF_FIELD_HIDE_EMAIL, '', 'tooltip.png', _JSMF_FIELD_HIDE_EMAIL); ?>
                                </td>
                                <td align="left" style="vertical-align: middle;">
                                    <input type="radio" name="jsmfConfig[hide_email]" value="1" <?php echo strcasecmp($jsmfConfig->hide_email, 1) == 0 ? 'checked="checked"' : '' ; ?> id="hide_email1" />
                                    <label for="hide_email1"><?php echo _JSMF_ENABLE; ?></label>
                                </td>
                                <td align="left" style="vertical-align: middle;">
                                    <input type="radio" name="jsmfConfig[hide_email]" value="0" <?php echo strcasecmp($jsmfConfig->hide_email, 0) == 0 ? 'checked="checked"' : '' ; ?> id="hide_email0" />
                                    <label for="hide_email0"><?php echo _JSMF_DISABLE; ?></label>
                                </td>
                            </tr>
                            <tr>
                                <td align="right" style="vertical-align: middle;">
                                    <?php echo mosToolTip(_JSMF_FIELD_SMF_REDIRECT_HELP, _JSMF_FIELD_SMF_REDIRECT, '', 'tooltip.png', _JSMF_FIELD_SMF_REDIRECT); ?>
                                </td>
                                <td align="left" style="vertical-align: middle;">
                                    <input type="radio" name="jsmfConfig[login_redirect]" value="1" <?php echo strcasecmp($jsmfConfig->login_redirect, 1) == 0 ? 'checked="checked"' : '' ; ?> id="login_redirect1" />
                                    <label for="login_redirect1"><?php echo _JSMF_ENABLE; ?></label>
                                </td>
                                <td align="left" style="vertical-align: middle;">
                                    <input type="radio" name="jsmfConfig[login_redirect]" value="0" <?php echo strcasecmp($jsmfConfig->login_redirect, 0) == 0 ? 'checked="checked"' : '' ; ?> id="login_redirect0" />
                                    <label for="login_redirect0"><?php echo _JSMF_DISABLE; ?></label>
                                </td>
                            </tr>
                            <tr>
                                <td align="right" style="vertical-align: middle;">
                                    <?php echo mosToolTip(_JSMF_FIELD_JOOMLA_REDIRECT_HELP, _JSMF_FIELD_JOOMLA_REDIRECT, '', 'tooltip.png', _JSMF_FIELD_JOOMLA_REDIRECT); ?>
                                </td>
                                <td align="left" style="vertical-align: middle;">
                                    <input type="radio" name="jsmfConfig[logout_redirect]" value="1" <?php echo strcasecmp($jsmfConfig->logout_redirect, 1) == 0 ? 'checked="checked"' : '' ; ?> id="logout_redirect1" />
                                    <label for="logout_redirect1"><?php echo _JSMF_ENABLE; ?></label>
                                </td>
                                <td align="left" style="vertical-align: middle;">
                                    <input type="radio" name="jsmfConfig[logout_redirect]" value="0" <?php echo strcasecmp($jsmfConfig->logout_redirect, 0) == 0  ? 'checked="checked"' : '' ; ?> id="logout_redirect0" />
                                    <label for="logout_redirect0"><?php echo _JSMF_DISABLE; ?></label>
                                </td>
                            </tr>
                            <tr>
                                <td align="right" style="vertical-align: middle;">
                                    <?php echo mosToolTip(_JSMF_FIELD_PATHWAY_HELP, _JSMF_FIELD_PATHWAY, '', 'tooltip.png', _JSMF_FIELD_PATHWAY); ?>
                                </td>
                                <td align="left" style="vertical-align: middle;">
                                    <input type="radio" name="jsmfConfig[pathway]" value="1" <?php echo strcasecmp($jsmfConfig->pathway, 1) == 0 ? 'checked="checked"' : '' ; ?> id="pathway1" />
                                    <label for="pathway1"><?php echo _JSMF_ENABLE; ?></label>
                                </td>
                                <td align="left" style="vertical-align: middle;">
                                    <input type="radio" name="jsmfConfig[pathway]" value="0" <?php echo strcasecmp($jsmfConfig->pathway, 0) == 0  ? 'checked="checked"' : '' ; ?> id="pathway0" />
                                    <label for="pathway0"><?php echo _JSMF_DISABLE; ?></label>
                                </td>
                            </tr>
                            <tr>
                                <td align="right" style="vertical-align: middle;">
                                    <?php echo mosToolTip(_JSMF_FIELD_PAGETITLES_HELP, _JSMF_FIELD_PAGETITLES, '', 'tooltip.png', _JSMF_FIELD_PAGETITLES); ?>
                                </td>
                                <td align="left" style="vertical-align: middle;">
                                    <input type="radio" name="jsmfConfig[pagetitles]" value="1" <?php echo strcasecmp($jsmfConfig->pagetitles, 1) == 0 ? 'checked="checked"' : '' ; ?> id="pagetitles1" />
                                    <label for="pagetitles1"><?php echo _JSMF_ENABLE; ?></label>
                                </td>
                                <td align="left" style="vertical-align: middle;">
                                    <input type="radio" name="jsmfConfig[pagetitles]" value="0" <?php echo strcasecmp($jsmfConfig->pagetitles, 0) == 0  ? 'checked="checked"' : '' ; ?> id="pagetitles0" />
                                    <label for="pagetitles0"><?php echo _JSMF_DISABLE; ?></label>
                                </td>
                            </tr>
                            <tr>
                                <td align="right" style="vertical-align: middle;">
                                    <?php echo mosToolTip(_JSMF_FIELD_CSS_HELP, _JSMF_FIELD_CSS, '', 'tooltip.png', _JSMF_FIELD_CSS); ?>
                                </td>
                                <td align="left" style="vertical-align: middle;">
                                    <input type="radio" name="jsmfConfig[css]" value="1" <?php echo strcasecmp($jsmfConfig->css, 1) == 0 ? 'checked="checked"' : '' ; ?> id="css1" />
                                    <label for="css1"><?php echo _JSMF_ENABLE; ?></label>
                                </td>
                                <td align="left" style="vertical-align: middle;">
                                    <input type="radio" name="jsmfConfig[css]" value="0" <?php echo strcasecmp($jsmfConfig->css, 0) == 0  ? 'checked="checked"' : '' ; ?> id="css0" />
                                    <label for="css0"><?php echo _JSMF_DISABLE; ?></label>
                                </td>
                            </tr>
                            <tr>
                                <td align="right" style="vertical-align: middle;">
                                    <?php echo mosToolTip(_JSMF_FIELD_DESCRIPTION_HELP, _JSMF_FIELD_DESCRIPTION, '', 'tooltip.png', _JSMF_FIELD_DESCRIPTION); ?>
                                </td>
                                <td align="left" style="vertical-align: middle;">
                                    <input type="radio" name="jsmfConfig[description]" value="1" <?php echo strcasecmp($jsmfConfig->description, 1) == 0 ? 'checked="checked"' : '' ; ?> id="description1" />
                                    <label for="description1"><?php echo _JSMF_ENABLE; ?></label>
                                </td>
                                <td align="left" style="vertical-align: middle;">
                                    <input type="radio" name="jsmfConfig[description]" value="0" <?php echo strcasecmp($jsmfConfig->description, 0) == 0  ? 'checked="checked"' : '' ; ?> id="description0" />
                                    <label for="description0"><?php echo _JSMF_DISABLE; ?></label>
                                </td>
                            </tr>
                            <tr>
                                <td align="right" style="vertical-align: middle;">
                                    <?php echo mosToolTip(_JSMF_FIELD_DEFAULT_KEYWORDS_HELP, _JSMF_FIELD_DEFAULT_KEYWORDS, '', 'tooltip.png', _JSMF_FIELD_DEFAULT_KEYWORDS); ?>
                                </td>
                                <td align="left" style="vertical-align: middle;">
                                    <input type="radio" name="jsmfConfig[def_keywords]" value="1" <?php echo strcasecmp($jsmfConfig->def_keywords, 1) == 0 ? 'checked="checked"' : '' ; ?> id="def_keywords1" />
                                    <label for="keywords1"><?php echo _JSMF_ENABLE; ?></label>
                                </td>
                                <td align="left" style="vertical-align: middle;">
                                    <input type="radio" name="jsmfConfig[def_keywords]" value="0" <?php echo strcasecmp($jsmfConfig->def_keywords, 0) == 0  ? 'checked="checked"' : '' ; ?> id="def_keywords0" />
                                    <label for="keywords0"><?php echo _JSMF_DISABLE; ?></label>
                                </td>
                            </tr>
                            <tr>
                                <td align="right" style="vertical-align: middle;">
                                    <?php echo mosToolTip(_JSMF_FIELD_KEYWORDS_HELP, _JSMF_FIELD_KEYWORDS, '', 'tooltip.png', _JSMF_FIELD_KEYWORDS); ?>
                                </td>
                                <td align="left" style="vertical-align: middle;">
                                    <input type="radio" name="jsmfConfig[keywords]" value="1" <?php echo strcasecmp($jsmfConfig->keywords, 1) == 0 ? 'checked="checked"' : '' ; ?> id="keywords1" />
                                    <label for="keywords1"><?php echo _JSMF_ENABLE; ?></label>
                                </td>
                                <td align="left" style="vertical-align: middle;">
                                    <input type="radio" name="jsmfConfig[keywords]" value="0" <?php echo strcasecmp($jsmfConfig->keywords, 0) == 0  ? 'checked="checked"' : '' ; ?> id="keywords0" />
                                    <label for="keywords0"><?php echo _JSMF_DISABLE; ?></label>
                                </td>
                            </tr>
                            <tr>
                                <td align="right" style="vertical-align: middle;">
                                    <?php echo mosToolTip(_JSMF_FIELD_REGISTRATION_SYSTEM_HELP, _JSMF_FIELD_REGISTRATION_SYSTEM, '', 'tooltip.png', _JSMF_FIELD_REGISTRATION_SYSTEM); ?>
                                </td>
                                <td align="left" style="vertical-align: middle;">
                                    <input type="radio" name="jsmfConfig[reg_module]" value="smf" <?php echo strcasecmp($jsmfConfig->reg_module, 'smf') == 0 ? 'checked="checked"' : '' ; ?> id="reg_modulesmf" />
                                    <label for="reg_modulesmf">SMF</label>
                                </td>
                                <td align="left" style="vertical-align: middle;">
                                    <input type="radio" name="jsmfConfig[reg_module]" value="joomla" <?php echo strcasecmp($jsmfConfig->reg_module, 'joomla') == 0 ? 'checked="checked"' : '' ; ?> id="reg_modulejoomla" />
                                    <label for="reg_modulejoomla">Joomla/Mambo</label>
                                </td>
                                <td align="left" style="vertical-align: middle;">
                                    <input type="radio" name="jsmfConfig[reg_module]" value="cb" <?php echo strcasecmp($jsmfConfig->reg_module, 'cb') == 0 ? 'checked="checked"' : '' ; ?> id="reg_modulecb" />
                                    <label for="reg_modulecb">CB</label>
                                </td>
                                <td align="left" style="vertical-align: middle;">
                                    <input type="radio" name="jsmfConfig[reg_module]" value="cbe" <?php echo strcasecmp($jsmfConfig->reg_module, 'cbe') == 0 ? 'checked="checked"' : '' ; ?> id="reg_modulecbe" />
                                    <label for="reg_modulecbe">CBE</label>
                                </td>
                            </tr>
                            <tr>
                                <td align="right" style="vertical-align: middle;">
                                    <?php echo mosToolTip(_JSMF_FIELD_LOGIN_MODULE_HELP, _JSMF_FIELD_LOGIN_MODULE, '', 'tooltip.png', _JSMF_FIELD_LOGIN_MODULE); ?>
                                </td>
                                <td align="left" style="vertical-align: middle;">
                                    <input type="radio" name="jsmfConfig[login_module]" value="mod_jsmf_login" <?php echo strcasecmp($jsmfConfig->login_module, 'mod_jsmf_login') == 0 ? 'checked="checked"' : '' ; ?> id="login_modulejsmf" />
                                    <label for="login_modulejsmf">Joomla-SMF</label>
                                </td>
                                <td align="left" style="vertical-align: middle;">
                                    <input type="radio" name="jsmfConfig[login_module]" value="mod_login" <?php echo strcasecmp($jsmfConfig->login_module, 'mod_login') == 0 ? 'checked="checked"' : '' ; ?> id="login_modulejoomla" />
                                    <label for="login_modulejoomla">Joomla/Mambo</label>
                                </td>
                                <td align="left" style="vertical-align: middle;">
                                    <input type="radio" name="jsmfConfig[login_module]" value="mod_cblogin" <?php echo strcasecmp($jsmfConfig->login_module, 'mod_cblogin') == 0 ? 'checked="checked"' : '' ; ?> id="login_modulecb" />
                                    <label for="login_modulecb">CB</label>
                                </td>
                                <td align="left" style="vertical-align: middle;">
                                    <input type="radio" name="jsmfConfig[login_module]" value="mod_cbelogin" <?php echo strcasecmp($jsmfConfig->login_module, 'mod_cbelogin') == 0 ? 'checked="checked"' : '' ; ?> id="login_modulecbe" />
                                    <label for="login_modulecbe">CBE</label>
                                </td>
                            </tr>
                            <?php
                            if (!$jsmfAdmin->isComInstalled('Community Builder%')) {
                            //if cb is not installed make sure cb profile is disabled
                            ?>
                            <input type="hidden" name="jsmfConfig[cb_profile]" value="0" />
                            <tr>
                                <td align="right" style="vertical-align: middle;">
                                    <?php echo mosToolTip(_JSMF_FIELD_PMS_HELP, _JSMF_FIELD_PMS, '', 'tooltip.png', _JSMF_FIELD_PMS); ?>
                                </td>
                                <td align="left" style="vertical-align: middle;">
                                    <input type="radio" name="jsmfConfig[pms]" value="smf" <?php echo strcasecmp($jsmfConfig->pms, 'smf') == 0 ? 'checked="checked"' : '' ; ?> id="pms_smf" />
                                    <label for="pms_smf">SMF</label>
                                </td>
                                <td align="left" style="vertical-align: middle;">
                                    <input type="radio" name="jsmfConfig[pms]" value="uddeim" <?php echo strcasecmp($jsmfConfig->pms, 'uddeim') == 0 ? 'checked="checked"' : '' ; ?> id="pms_uddeim" />
                                    <label for="pms_uddeim">UddeIM</label>
                                </td>
                                <td align="left" style="vertical-align: middle;">
                                    <input type="radio" name="jsmfConfig[pms]" value="jim" <?php echo strcasecmp($jsmfConfig->pms, 'jim') == 0 ? 'checked="checked"' : '' ; ?> id="pms_jim" />
                                    <label for="pms_jim">JIM</label>
                                </td>
                                <td align="left" style="vertical-align: middle;">
                                    <input type="radio" name="jsmfConfig[pms]" value="pms" <?php echo strcasecmp($jsmfConfig->pms, 'pms') == 0 ? 'checked="checked"' : '' ; ?> id="pms_pms" />
                                    <label for="pms_pms">PMS</label>
                                </td>
                                <td align="left" style="vertical-align: middle;">
                                    <input type="radio" name="jsmfConfig[pms]" value="mypms" <?php echo strcasecmp($jsmfConfig->pms, 'mypms') == 0 ? 'checked="checked"' : '' ; ?> id="pms_mypms" />
                                    <label for="pms_mypms">Clexus</label>
                                </td>
                                <td align="left" style="vertical-align: middle;">
                                    <input type="radio" name="jsmfConfig[pms]" value="missus" <?php echo strcasecmp($jsmfConfig->pms, 'missus') == 0 ? 'checked="checked"' : '' ; ?> id="pms_missus" />
                                    <label for="pms_missus">Missus</label>
                                </td>
                            </tr>
                            <tr>
                                <td align="right" style="vertical-align: middle;">
                                    <?php echo mosToolTip(_JSMF_FIELD_CACHE_USER_ARRAY_HELP, _JSMF_FIELD_CACHE_USER_ARRAY, '', 'tooltip.png', _JSMF_FIELD_CACHE_USER_ARRAY); ?>
                                </td>
                                <td align="left" style="vertical-align: middle;">
                                    <input type="radio" name="jsmfConfig[cache_user_array]" value="1" <?php echo strcasecmp($jsmfConfig->cache_user_array, 1) == 0  ? 'checked="checked"' : '' ; ?> id="cache_user_array1" />
                                    <label for="cache_user_array1"><?php echo _JSMF_ENABLE; ?></label>
                                </td>
                                <td align="left" style="vertical-align: middle;" colspan="2">
                                    <input type="radio" name="jsmfConfig[cache_user_array]" value="0" <?php echo strcasecmp($jsmfConfig->cache_user_array, 0) == 0 ? 'checked="checked"' : '' ; ?> id="cache_user_array0" />
                                    <label for="cache_user_array0"><?php echo _JSMF_DISABLE; ?></label>
                                </td>
                            </tr>
                            <?php } ?>
                            <tr>
                                <td align="right" style="vertical-align: middle;">
                                    <?php echo mosToolTip(_JSMF_FIELD_USE_FUNCTION_CACHE_HELP, _JSMF_FIELD_USE_FUNCTION_CACHE, '', 'tooltip.png', _JSMF_FIELD_USE_FUNCTION_CACHE); ?>
                                </td>
                                <td align="left" style="vertical-align: middle;">
                                    <input type="radio" name="jsmfConfig[use_function_cache]" value="1" <?php echo strcasecmp($jsmfConfig->use_function_cache, 1) == 0 ? 'checked="checked"' : '' ; ?> id="use_function_cache1"/>
                                    <label for="use_function_cache1"><?php echo _JSMF_ENABLE; ?></label>
                                </td>
                                <td align="left" style="vertical-align: middle;">
                                    <input type="radio" name="jsmfConfig[use_function_cache]" value="0" <?php echo strcasecmp($jsmfConfig->use_function_cache, 0) == 0 ? 'checked="checked"' : '' ; ?> id="use_function_cache0"/>
                                    <label for="use_function_cache0"><?php echo _JSMF_DISABLE; ?></label>
                                </td>
                            </tr>
                            <tr>
                                <td align="right" style="vertical-align: middle;">
                                    <?php echo "Debug:" ?>
                                </td>
                                <td align="left" style="vertical-align: middle;">
                                    <input type="radio" name="jsmfConfig[debug]" value="1" <?php echo strcasecmp($jsmfConfig->debug, 1) == 0 ? 'checked="checked"' : '' ; ?> id="jsmf_debug1" />
                                    <label for="jsmf_debug1"><?php echo _JSMF_ENABLE; ?></label>
                                </td>
                                <td align="left" style="vertical-align:middle;">
                                    <input type="radio" name="jsmfConfig[debug]" value="0" <?php echo strcasecmp($jsmfConfig->debug, 0) == 0 ? 'checked="checked"' : '' ; ?> id="jsmf_debug0" />
                                    <label for="jsmf_debug0"><?php echo _JSMF_DISABLE; ?></label>
                                </td>
                            </tr>
                        </table>
                    </td>
                </tr>
            </table>
            <?php
      }

   /**
     * Show Community Builder Tab
     *
     *
     * @access private
     * @param object reference $jsmfConfig Joomla-SMF configurations
     * @param object reference $jsmfAdmin Joomla-SMF Administration functions
     * @return n/a
     */
    function __showCBTab(&$jsmfConfig, &$jsmfAdmin)
    {
         ?>
            <!-- CONFIGURATION TAB -->
            <table width="100%" border="0" cellpadding="2" cellspacing="2">
                <tr>
                    <th style="vertical-align: top;" align="left" colspan="2">
                        <?php echo _JSMF_TAB_CB_HEADER; ?>
                        <hr />
                    </th>
                </tr>
                <tr>
                    <td style="vertical-align: top;" align="left">

                        <table border="0" cellpadding="2" cellspacing="2" class="adminForm">
                            <tr>
                                <td align="right" style="vertical-align: middle;">
                                    <?php echo mosToolTip(_JSMF_FIELD_CB_PROFILE_HELP, _JSMF_FIELD_CB_PROFILE, '', 'tooltip.png', _JSMF_FIELD_CB_PROFILE); ?>
                                </td>
                                <td align="left" style="vertical-align: middle;">
                                    <input type="radio" name="jsmfConfig[cb_profile]" value="1" <?php echo strcasecmp($jsmfConfig->cb_profile, 1) == 0 ? 'checked="checked"' : '' ; ?> id="cb_profile1" />
                                    <label for="cb_profile1"><?php echo _JSMF_ENABLE; ?></label>
                                </td>
                                <td align="left" style="vertical-align: middle;">
                                    <input type="radio" name="jsmfConfig[cb_profile]" value="0" <?php echo strcasecmp($jsmfConfig->cb_profile, 0) == 0 ? 'checked="checked"' : '' ; ?> id="cb_profile0"/>
                                    <label for="cb_profile0"><?php echo _JSMF_DISABLE; ?></label>
                                </td>
                            </tr>
                            <tr>
                                <td align="right" style="vertical-align: middle;">
                                    <?php echo mosToolTip(_JSMF_FIELD_PMS_HELP, _JSMF_FIELD_PMS, '', 'tooltip.png', _JSMF_FIELD_PMS); ?>
                                </td>
                                <td align="left" style="vertical-align: middle;">
                                    <input type="radio" name="jsmfConfig[pms]" value="smf" <?php echo strcasecmp($jsmfConfig->pms, 'smf') == 0 ? 'checked="checked"' : '' ; ?> id="pms_smf" />
                                    <label for="pms_smf">SMF</label>
                                </td>
                                <td align="left" style="vertical-align: middle;">
                                    <input type="radio" name="jsmfConfig[pms]" value="uddeim" <?php echo strcasecmp($jsmfConfig->pms, 'uddeim') == 0 ? 'checked="checked"' : '' ; ?> id="pms_uddeim" />
                                    <label for="pms_uddeim">UddeIM</label>
                                </td>
                                <td align="left" style="vertical-align: middle;">
                                    <input type="radio" name="jsmfConfig[pms]" value="jim" <?php echo strcasecmp($jsmfConfig->pms, 'jim') == 0 ? 'checked="checked"' : '' ; ?> id="pms_jim" />
                                    <label for="pms_jim">JIM</label>
                                </td>
                                <td align="left" style="vertical-align: middle;">
                                    <input type="radio" name="jsmfConfig[pms]" value="pms" <?php echo strcasecmp($jsmfConfig->pms, 'pms') == 0 ? 'checked="checked"' : '' ; ?> id="pms_pms" />
                                    <label for="pms_pms">PMS</label>
                                </td>
                                <td align="left" style="vertical-align: middle;">
                                    <input type="radio" name="jsmfConfig[pms]" value="mypms" <?php echo strcasecmp($jsmfConfig->pms, 'mypms') == 0 ? 'checked="checked"' : '' ; ?> id="pms_mypms" />
                                    <label for="pms_mypms">Clexus</label>
                                </td>
                                <td align="left" style="vertical-align: middle;">
                                    <input type="radio" name="jsmfConfig[pms]" value="missus" <?php echo strcasecmp($jsmfConfig->pms, 'missus') == 0 ? 'checked="checked"' : '' ; ?> id="pms_missus" />
                                    <label for="pms_missus">Missus</label>
                                </td>
                            </tr>
                            <tr>
                                <td align="right" style="vertical-align: middle;">
                                    <?php echo mosToolTip(_JSMF_FIELD_CACHE_USER_ARRAY_HELP, _JSMF_FIELD_CACHE_USER_ARRAY, '', 'tooltip.png', _JSMF_FIELD_CACHE_USER_ARRAY); ?>
                                </td>
                                <td align="left" style="vertical-align: middle;">
                                    <input type="radio" name="jsmfConfig[cache_user_array]" value="1" <?php echo strcasecmp($jsmfConfig->cache_user_array, 1) == 0  ? 'checked="checked"' : '' ; ?> id="cache_user_array1" />
                                    <label for="cache_user_array1"><?php echo _JSMF_ENABLE; ?></label>
                                </td>
                                <td align="left" style="vertical-align: middle;" colspan="2">
                                    <input type="radio" name="jsmfConfig[cache_user_array]" value="0" <?php echo strcasecmp($jsmfConfig->cache_user_array, 0) == 0 ? 'checked="checked"' : '' ; ?> id="cache_user_array0" />
                                    <label for="cache_user_array0"><?php echo _JSMF_DISABLE; ?></label>
                                </td>
                            </tr>
                        </table>
                    </td>
                </tr>
            </table>
            <?php
      }

   /**
     * Show Joomap Tab
     *
     *
     * @access private
     * @param object reference $jsmfConfig Joomla-SMF configurations
     * @param object reference $jsmfAdmin Joomla-SMF Administration functions
     * @return n/a
     */
    function __showJoomapTab(&$jsmfConfig, &$jsmfAdmin)
    {
         ?>
            <!-- CONFIGURATION TAB -->
            <table width="100%" border="0" cellpadding="2" cellspacing="2">
                <tr>
                    <th style="vertical-align: top;" align="left" colspan="2">
                        <?php echo _JSMF_TAB_JOOMAP_HEADER; ?>
                        <hr />
                    </th>
                </tr>
                <tr>
                    <td align="left" style="vertical-align: top;">

                        <table border="0" cellpadding="2" cellspacing="2" class="adminForm">
                            <tr>
                                <td align="right" style="vertical-align: middle;">
                                    <?php echo mosToolTip(_JSMF_FIELD_JOOMAP_FROM_HELP, _JSMF_FIELD_JOOMAP_FROM, '', 'tooltip.png', _JSMF_FIELD_JOOMAP_FROM); ?>
                                </td>
                                <td align="left" style="vertical-align: middle;">
                                    <input type="text" size="5" name="jsmfConfig[jm_from]" value="<?php echo "$jsmfConfig->jm_from"; ?>" onkeyup="return isInteger(this)" />
                                </td>

                            </tr>
                            <tr>
                                <td align="right" style="vertical-align: middle;">
                                    <?php echo mosToolTip(_JSMF_FIELD_JOOMAP_EMPTY_HELP, _JSMF_FIELD_JOOMAP_EMPTY, '', 'tooltip.png', _JSMF_FIELD_JOOMAP_EMPTY); ?>
                                </td>
                                <td align="left" style="vertical-align: middle;">
                                    <input type="radio" name="jsmfConfig[jm_empty]" value="1" <?php echo strcasecmp($jsmfConfig->jm_empty, 1) == 0 ? 'checked="checked"' : '' ; ?> id="jm_empty1" />
                                    <label for="jm_empty1"><?php echo _JSMF_ENABLE; ?></label>
                                </td>
                                <td align="left" style="vertical-align: middle;">
                                    <input type="radio" name="jsmfConfig[jm_empty]" value="0" <?php echo strcasecmp($jsmfConfig->jm_empty, 0) == 0  ? 'checked="checked"' : '' ; ?> id="jm_empty0" />
                                    <label for="jm_empty0"><?php echo _JSMF_DISABLE; ?></label>
                                </td>
                            </tr>
                            <tr>
                                <td align="right" style="vertical-align: middle;">
                                    <?php echo mosToolTip(_JSMF_FIELD_JOOMAP_TOPICS_HELP, _JSMF_FIELD_JOOMAP_TOPICS, '', 'tooltip.png', _JSMF_FIELD_JOOMAP_TOPICS); ?>
                                </td>
                                <td align="left" style="vertical-align: middle;">
                                    <input type="radio" name="jsmfConfig[jm_topics]" value="1" <?php echo strcasecmp($jsmfConfig->jm_topics, 1) == 0 ? 'checked="checked"' : '' ; ?> id="jm_topics1" />
                                    <label for="jm_topics1"><?php echo _JSMF_ENABLE; ?></label>
                                </td>
                                <td align="left" style="vertical-align: middle;">
                                    <input type="radio" name="jsmfConfig[jm_topics]" value="0" <?php echo strcasecmp($jsmfConfig->jm_topics, 0) == 0  ? 'checked="checked"' : '' ; ?> id="jm_topics0" />
                                    <label for="jm_topics0"><?php echo _JSMF_DISABLE; ?></label>
                                </td>
                            </tr>
                            <tr>
                                <td align="right" style="vertical-align: middle;">
                                    <?php echo mosToolTip(_JSMF_FIELD_JOOMAP_STICKY_HELP, _JSMF_FIELD_JOOMAP_STICKY, '', 'tooltip.png', _JSMF_FIELD_JOOMAP_STICKY); ?>
                                </td>
                                <td align="left" style="vertical-align: middle;">
                                    <input type="radio" name="jsmfConfig[jm_sticky]" value="1" <?php echo strcasecmp($jsmfConfig->jm_sticky, 1) == 0 ? 'checked="checked"' : '' ; ?> id="jm_sticky1" />
                                    <label for="jm_sticky1"><?php echo _JSMF_ENABLE; ?></label>
                                </td>
                                <td align="left" style="vertical-align: middle;">
                                    <input type="radio" name="jsmfConfig[jm_sticky]" value="0" <?php echo strcasecmp($jsmfConfig->jm_sticky, 0) == 0  ? 'checked="checked"' : '' ; ?> id="jm_sticky0" />
                                    <label for="jm_sticky0"><?php echo _JSMF_DISABLE; ?></label>
                                </td>
                            </tr>
                        </table>
                    </td>
                </tr>
            </table>
            <?php
      }


    /**
     * Display the Permission Tab
     *
     *
     * @access private
     * @param object reference $jsmfConfig Joomla-SMF configurations
     * @param object reference $jsmfAdmin Joomla-SMF Administration functions
     * @return n/a
     * @global string $mosConfig_absolute_path
     * @global string $mosConfig_live_site
     */
    function __showPermTab(&$jsmfConfig, &$jsmfAdmin)
    {
        global $mosConfig_absolute_path, $mosConfig_live_site;
        ?>
        <!-- PERMISSION TAB -->

        <table width="100%" border="0" cellpadding="2" cellspacing="2">
            <tr>
                <th align="left" style="vertical-align: top;" colspan="2">
                    <?php echo _JSMF_HEADER_PERMISSION_SETTINGS; ?>
                    <hr />
                </th>
            </tr>
            <tr>
                <td style="vertical-align: top;">
                    <table width"100%" border="0" cellpadding="2" cellspacing="2" align="left">
                    <?php
                    if (empty($jsmfConfig->smf_path)) {
                    	?>
                        <tr>
                            <th style="vertical-align: top;" colspan="3" align="left" >
                                <?php echo _JSMF_PERMISSION_MSG; ?>
                                <hr />
                            </th>
                        </tr>
                    <?php
                    } else {
                    	//who are we?
                        $proc_owner = (object) posix_getpwuid(posix_geteuid());
                        //$proc_group = (object) posix_getgrgid(posix_getegid());
                        $files = array( dirname($mosConfig_absolute_path.'/index.php'),
                                        $mosConfig_absolute_path.'/index.php',
                                        dirname($jsmfConfig->smf_path.'/index.php'),
                                        $jsmfConfig->smf_path.'/index.php',
                                        dirname($jsmfConfig->smf_path.'/Sources/Subs-Post.php'),
                                        $jsmfConfig->smf_path.'/Sources/Subs-Post.php',
                                        dirname($jsmfConfig->smf_path.'/Sources/Subs.php'),
                                        $jsmfConfig->smf_path.'/Sources/Subs.php',
                                        dirname($jsmfConfig->smf_path.'/Themes/default/xml_topic.js'),
                                        $jsmfConfig->smf_path.'/Themes/default/xml_topic.js' );
                        foreach ($files as $file) {

                        	$file_owner = (object) posix_getpwuid(fileowner($file));
                            $file_group = (object) posix_getgrgid(filegroup($file));
                        	?>
                                <tr>
                                    <td>
                                        <code><?php echo $file; ?></code>
                                    </td>
                                    <td>
                                        <code><?php echo $file_owner->name.':'.$file_group->name; ?></code>
                                    </td>
                                    <td>
                                        <code><?php echo $jsmfAdmin->displayPerms(fileperms($file)); ?></code>
                                    </td>
                                    <td>
                                    <?php
                                    if (is_writeable($file)) {
                                    	echo jsmfAdminHTML::paintgreen(_JSMF_MSG_WRITABLE);
                                    ?>
                                    </td>
                                    <td>
                                        <?php echo "<b><a href=\"$mosConfig_live_site/administrator/index2.php?option=".$jsmfConfig->option."&amp;task=chmod&amp;file=$file&amp;mode=".(is_dir($file) ? "0755" : "0644")."\">"._JSMF_MSG_MAKE_NOT_WRITEABLE.(is_dir($file) ? "(0755)" : "(0644)")."</a></b>";?>
                                    </td>
                                    <?php
                                    } else {
                                    	echo jsmfAdminHTML::paintred(_JSMF_MSG_NOT_WRITABLE);
                                    ?>
                                    </td>
                                    <td>
                                        <?php echo "<b><a href=\"$mosConfig_live_site/administrator/index2.php?option=".$jsmfConfig->option."&amp;task=chmod&amp;file=$file&amp;mode=".(is_dir($file) ? "0777" : "0666")."\">"._JSMF_MSG_MAKE_WRITEABLE.(is_dir($file) ? "(0777)" : "(0666)")."</a></b>";?>
                                    </td>
                                    <?php
                                    }
                                    ?>
                                </tr>
                            <?php
                        }
                    }
                        ?>
                    </table>
                </td>
            </tr>
        </table>
        <?php
    }


    /**
     * Display the General tab
     *
     *
     * @access private
     * @param object reference $jsmfConfig Joomla-SMF configurations
     * @param object reference $jsmfAdmin Joomla-SMF Administration functions
     * @param string $smf_version SMF version
     * @return n/a
     * @global object $mainframe
     * @global object $_VERSION Joomla/Mambo version string
     */
    function __showGeneralTab(&$jsmfConfig, &$jsmfAdmin, $smf_version)
    {
        global $mainframe, $_VERSION;

        /**
         * Include Joomla-SMF syndication file
         */
        require_once(JSMFADMIN_BASE.'/admin.smf.class.php');
        ?>
        <!--General Tab -->
                <table width="100%" border="0" cellpadding="2" cellspacing="2">
                    <tr>
                        <th style="vertical-align: top;" align="left" colspan="2">
                            <?php echo _JSMF_TAB_GENERAL_HEADER; ?>
                            <hr />
                        </th>
                    </tr>
                    <tr>
                        <td style="vertical-align: top;" width="65%">
                            <table width="100%" border="0" cellpadding="2" cellspacing="2">
                                <tr>
                                    <td>
                                        <?php echo _JSMF_TEXT_GENERAL_INFORMATION; ?>
                                    </td>
                                </tr>
                                <tr>
                                    <td>
                                        <hr />
                                        <table width="100%" border="0" cellpadding="2" cellspacing="2">
                                            <tr>
                                                <td style="vertical-align: top;">
                                                    <table width="100%" border="0" cellpadding="2" cellspacing="2">
                                                        <tr>
                                                            <td style="vertical-align: top;">
                                                                <?php echo _JSMF_TEXT_COMPATIBILITY_INFORMATION; ?><br />
                                                                <a href="http://www.joomla.org" target="_blank">Joomla 1.0.x+</a><br />
                                                                <a href="http://www.mamboserver.com" target="_blank">Mambo 4.5.2+</a><br />
                                                                <a href="http://www.simplemachines.org" target="_blank">Simple Machines Forum 1.1RC2+</a><br />
                                                                <a href="http://www.joomlapolis.com" target="_blank">Community Builder 1.0+</a><br />
                                                            </td>
                                                        </tr>
                                                    </table>
                                                </td>
                                                <td style="vertical-align: top;">
                                                    <table width="100%" border="0" cellpadding="2" cellspacing="2">
                                                        <tr>
                                                            <td style="vertical-align: top;">
                                                                <?php echo _JSMF_TEXT_VERSION_INFORMATION; ?><br />
                                                                <?php echo _JSMF_TEXT_JOOMLA_VERSION.' '.$_VERSION->getShortVersion(); ?><br />
                                                                <?php echo _JSMF_TEXT_SMF_VERSION.' '.$smf_version; ?><br />
                                                                <?php echo _JSMF_TEXT_JOOMLA_SMF_VERSION." <b>".$jsmfAdmin->readComVersion(); ?></b><br />
                                                                <?php
                                                                $rdf = new jsmfRDF();
                                                                $base = str_replace("?", "&amp;", basename($jsmfConfig->version_url));
                                                                if ($rdf->getRDF($jsmfConfig->version_url, 30)) {
                                                                    if (!$rdf->displayRDF($base, false, 1, _JSMF_TEXT_LATEST_JOOMLA_SMF_VERSION." ")) {
                                                                        echo _JSMF_MSG_ERR_CANNOT_REACH_SITE;
                                                                    }
                                                                } else {
                                                                    echo _JSMF_MSG_ERR_CANNOT_REACH_SITE;
                                                                }
                                                                ?><br />
                                                            </td>
                                                        </tr>
                                                    </table>
                                                </td>
                                            </tr>
                                        </table>
                                    </td>
                            </table>
                        </td>
                        <td style="vertical-align: top;">
                            <table width="100%" border="0" cellpadding="2" cellspacing="2">
                                <tr>
                                    <th style="vertical-align: top;" align="left">
                                        <?php echo _JSMF_TEXT_JOOMLAHACKS_UPDATES; ?>
                                        <hr />
                                    </th>
                                </tr>
                                <tr>
                                    <td style="vertical-align: top;" align="left" >
                                        <?php
                                            $base = str_replace("?", "&amp;", basename($jsmfConfig->announce_url));
                                            if ($rdf->getRDF($jsmfConfig->announce_url, 30)) {
                                                $rdf->displayRDF($base, false, 10, "");
                                            }
                                            $base = $jsmfConfig->news_url;
                                            $rdf->parseRSS($base);?>
                                    </td>
                                </tr>
                            </table>
                        </td>
                    </tr>
                </table>
            <?php
    }

    /**
     * Display the help tab
     *
     *
     * @access private
     * @param object reference $jsmfConfig Joomla-SMF configurations
     * @param object reference $jsmfAdmin Joomla-SMF Administration functions
     * @param string $smf_version SMF version
     * @return n/a
     * @global object $mainframe
     */
    function __showHelpTab(&$jsmfConfig, &$jsmfAdmin, $smf_version)
    {
    	global $mainframe, $_VERSION, $database;

        /**
         * Include Joomla-SMF syndication file
         */
        require_once(JSMFADMIN_BASE.'/admin.smf.class.php');
        ?>
        <!-- Help Tab -->
            <table width="100%" border="0" cellpadding="2" cellspacing="2">
                <tr>
                    <th style="vertical-align: top;" align="left" colspan="2">
                        <?php echo _JSMF_TAB_HELP_HEADER; ?>
                        <hr />
                    </th>
                </tr>
                <tr>
                    <td style="vertical-align: top;" align="left">
                        <table width="100%" border="0" cellpadding="2" cellspacing="2">
                            <tr>
                                <td style="vertical-align: top;" align="left">
                                    </form><!--end of joomla form-->
                                    <?php
                            		$premessage = "[QUOTE=Joomla-SMF Bridge Request][b]JOOMLA-SMF BRIDGE Version:[/b] ".$jsmfAdmin->readComVersion()."\n[b]JOOMLA Version:[/b] ".$_VERSION->getLongVersion()."\n[b]SMF Version:[/b]".$smf_version."[/QUOTE]\n\nPlease Describe the Issue:";
                                	?>
                            		<script type="text/javascript">
									function helpSubmit() {
										document.getElementById("gethelp").submit();
									}
									</script>
									<form id="gethelp" action="<?php echo $jsmfConfig->help_link; ?>" method="post"> <!-- http://www.joomlahacks.com/component/option,com_smf/Itemid,94/ -->
            							<input type="hidden" name="board" value="<?php echo $jsmfConfig->help_boardid; ?>" /> <!-- 47 -->
            							<input type="hidden" name="icon" value="question" />
            							<input type="hidden" name="subject" value="Help Request:" />
            							<input type="hidden" name="action" value="post" />
            							<input type="hidden" name="message" value="<?php echo $premessage; ?>" />
            							<input type="hidden" name="option" value="" />
            							<input type="hidden" name="goback" value="true" />
                            		<b><a style="cursor:pointer; text-decoration:none;" onclick="javascript:helpSubmit();"><?php echo _JSMF_NEED_HELP; ?></a></b><br />
                                </td>
                            </tr>
                            <tr>
                                <td style="vertical-align: top;" align="left">
                                    <?php
                                            $rdf = new jsmfRDF();
                                            $url = $jsmfConfig->help_url;
                                            $base = str_replace("?", "&amp;", basename($url));
                                            if ($rdf->getRDF($url, 30)) {
                                                 $rdf->displayRDF($base, FALSE, 1, "");
                                            } else {
                                                 echo '<br/><br/><br/><br/><br/><br/>';
                                            }
                                    ?>
                            	</td>
                            </tr>
                        </table>
                     </td>
                     <td align="left">
                        <table width="100%" border="0" cellpadding="2" cellspacing="2">
                            <tr>
                                <td style="vertical-align: top;" align="left">
                                    <a href="http://www.MamboServe.com" target="_blank">MamboServe.com</a><?php echo _JSMF_MAMBOSERVE_MSG;?><br/>
                                    <?php echo _JSMF_JOOMLAHACKS_PRE_MSG; ?><a href="http://www.JoomlaHacks.com" target="_blank">JoomlaHacks.com</a><?php echo _JSMF_JOOMLAHACKS_POST_MSG; ?><br/><br/>
                                </td>
                            </tr>
                        </table>
                     </td>
                </tr>
            </table>
        <?php

    }


    /**
     * Display error tab
     *
     *
     * @access private
     * @param string $error Error message
     * @return n/a
     * @global string $mosConfig_live_site
     * @global object $jsmfConfig Joomla-SMF configurations
     */
    function __showErrorTab($error)
    {
    	global $mosConfig_live_site, $jsmfConfig;
        ?>
        <!-- Error Tab -->
            <table width="100%" border="0" cellpadding="2" cellspacing="2">
                <tr>
                    <td style="vertical-align: top;" align="left">
                        <table width="100%" border="0" cellpadding="2" cellspacing="2">
                            <tr>
                                <td style="vertical-align: top;" align="left">
                                    <?php echo $error;?>

                                </td>
                            </tr>
                            <tr>
                                <td>
                                    <?php echo '<a href="'.$mosConfig_live_site.'/administrator/index2.php?option='.$jsmfConfig->option.'&amp;task=install">'._JSMF_TAB_INSTALLATION_TITLE .'</a><br />'; ?>
                                    <?php echo '<a href="'.$mosConfig_live_site.'/administrator/index2.php?option='.$jsmfConfig->option.'&amp;task=config">'._JSMF_TAB_CONFIGURATION_TITLE .'</a><br />'; ?>
                                    <?php echo '<a href="'.$mosConfig_live_site.'/administrator/index2.php?option='.$jsmfConfig->option.'&amp;task=about">'._JSMF_TAB_GENERAL_TITLE .'</a><br />'; ?>
                                </td>
                            </tr>
                        </table>
                     </td>
                </tr>
            </table>
        <?php
    }

    /**
     * Changes display color of $text to green
     *
     *
     * @access public
     * @param string $text
     * @return string
     */
    function paintGreen($text)
    {
        return '<font color="green">'.$text.'</font>';
    }

    /**
     * Changes display color of $text to red
     *
     *
     * @access public
     * @param string $text
     * @return string
     */
    function paintRed($text)
    {
        return '<font color="red"><b>'.$text.'</b></font>';
    }

}

?>