<?php
/* tabstop=4 tabreplace=space */
/**
 * Joomla-SMF Forum
 *
 * This file performs the tasks associated with installing the Joomla-SMF
 * Forum component.
 *
 * LICENSE: This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 * @category    Component
 * @package     com_smf
 * @author      Cowboy <ross@joomlahacks.com>
 * @author      Wolverine <joshualross@gmail.com>
 * @copyright   (C) JoomlaHacks.com. All rights reserved.
 * @license     http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @version     $Id: install.smf.php 295 2006-11-11 21:30:18Z joshualross $
 * @revision    $LastChangedRevision: 295 $
 * @date        $LastChangedDate: 2006-11-11 16:30:18 -0500 (Sat, 11 Nov 2006) $
 * @file        $HeadURL: http://scm.joomla.org/svn/repos/joomla-smf_2_0/install.smf.php $
 * @link        http://www.JoomlaHacks.com
 * @link        http://www.joshualross.us
 * @since       File available since Release 2.0
 *
 * Visit JoomlaHacks.com for more Joomla Hacks!
 */
//no direct access
defined( '_VALID_MOS' ) or die( 'Restricted access' );
global $mosConfig_absolute_path;
defined( 'JPATH_BASE' ) or define('JPATH_BASE', $mosConfig_absolute_path);
if (!defined('JSMFADMIN_BASE')) {
    /** #@+
     * Constants
     */
    /**
     * JSMFADMIN_BASE
     */
    define('JSMFADMIN_BASE', dirname(__FILE__));
    /** #@- */
}

/**
 * Joomla-SMF component install function called from Joomla install process
 *
 *
 * @return n/a
 * @global object $database Joomla database handle
 * @global object $mainframe
 * @global object $_VERSION Joomla/Mambo version object
 */
function com_install() {
    global $database, $mainframe, $_VERSION, $mosConfig_live_site, $mosConfig_lang;
    /**
     * Include Joomla-SMF language file
     */
    if (file_exists(JSMFADMIN_BASE.'/language/'.$mosConfig_lang.'.php')) {
        include_once(JSMFADMIN_BASE.'/language/'.$mosConfig_lang.'.php');
    } else {
        include_once(JSMFADMIN_BASE.'/language/english.php');
    }

    $jsmf_install_out = '
    <div align="left">
        <img src="../administrator/components/com_smf/images/logo.png" alt="JoomlaHacks.com" />
        <br /><strong>Joomla-SMF Forum</strong><br/>
    </div>';
/*
<table class="adminheading">
        <tr>
            <th class="install">
                <img src="../administrator/components/com_smf/images/logo.png" alt="JoomlaHacks.com" /><br /><strong>Joomla-SMF Forum</strong><br/>
            </th>
        </tr>
    </table>
*/
    $jsmf_install_out .= '
    <div align="left">
        <p>This component is released under the terms and conditions of the <a href="index2.php?option=com_admisc&task=license">GNU General Public License</a>.
        <br/>Please visit <a href="http://www.JoomlaHacks.com" title="JoomlaHacks.com" target="_blank">JoomlaHacks.com</a> for updates.</p>
    ';
/*    <table width="100%" border="0" cellpadding="2" cellspacing="2" class="adminForm">
        <tr>
            <td>
                <br/>This component is released under the terms and conditions of the <a href="index2.php?option=com_admisc&task=license">GNU General Public License</a>.
                <br/>Please visit <a href="http://www.JoomlaHacks.com">JoomlaHacks.com</a> for updates.
            </td>
        </tr>';*/


    $query =
        "INSERT INTO #__menu " .
        "( menutype, name, link, type, published, parent, componentid, sublevel, ordering, checked_out, checked_out_time, pollid, browserNav, access, utaccess ) " .
        "VALUES ('mainmenu', '"._JSMF_FORUM_LINK."', 'index.php?option=com_smf', 'components', 1, 0, 9999, 0, 8, 0, '0000-00-00 00:00:00', 0, 0, 0, 3)";
    $database->setQuery($query);
    $jsmf_install_out .= jsmf_showResult($database->query(), $database->getQuery());

    $query =
        "UPDATE #__components " .
        "SET admin_menu_img='../administrator/components/com_smf/images/menu_logo.png' " .
        "WHERE admin_menu_link='option=com_smf'";
    $database->setQuery($query);
    $jsmf_install_out .= jsmf_showResult($database->query(), $database->getQuery());

    $query =
        "UPDATE #__components " .
        "SET name = '"._JSMF_LINK_INSTALL."', admin_menu_alt = '"._JSMF_LINK_INSTALL."', admin_menu_img='js/ThemeOffice/install.png' " .
        "WHERE admin_menu_link='option=com_smf&task=install'";
    $database->setQuery($query);
    $jsmf_install_out .= jsmf_showResult($database->query(), $database->getQuery());;

    $query =
        "UPDATE #__components " .
        "SET name = '"._JSMF_LINK_CONFIG."', admin_menu_alt = '"._JSMF_LINK_CONFIG."', admin_menu_img='js/ThemeOffice/config.png' " .
        "WHERE admin_menu_link='option=com_smf&task=config'";
    $database->setQuery($query);
    $jsmf_install_out .= jsmf_showResult($database->query(), $database->getQuery());

    $query =
        "UPDATE #__components " .
        "SET name = '"._JSMF_LINK_ABOUT."', admin_menu_alt = '"._JSMF_LINK_ABOUT."', admin_menu_img='../administrator/components/com_smf/images/menu_logo.png' " .
        "WHERE admin_menu_link='option=com_smf&task=about'";
    $database->setQuery($query);
    $jsmf_install_out .= jsmf_showResult($database->query(), $database->getQuery());



    //now try to install our params correctly, or update if it was previously installed
    require_once (JSMFADMIN_BASE . '/admin.smf.class.php');
    $jsmfAdmin =& new jsmfAdmin();
    //start with the assumption we need to create a new table and params
//    $create_new = TRUE;

    $query =
        "SELECT id " .
        "FROM #__menu " .
        "WHERE link='index.php?option=com_smf' " .
        "LIMIT 1";
    $database->setQuery($query);
    $menu_id = $database->loadResult();
    $code = '';



    //first, check if old table is there
//    $query =
//        "SELECT config " .
//        "FROM #__jsmf_config";
//    $database->setQuery( $query );
    $query =
        "SHOW TABLES LIKE '%jsmf_config'";
    $database->setQuery($query);

    //second, if it is there, get the params
    if ($result = $database->loadResult()) {

        $jsmfConfig = $jsmfAdmin->loadParams(TRUE);
        //save some params
        if (isset($jsmfConfig->code) && !empty($jsmfConfig->code)) {
            $code = $jsmfConfig->code;
        }

//TODO test the selection of the menu id like our old one, it didn't produce
//the result we wanted, if the query fails for some reason we still try to update
        //third, check if itemid is set
        if (isset($jsmfConfig->itemid) && !empty($jsmfConfig->itemid)) {
        	//fourth, check if itemid is available as a component id
            $query =
                "SELECT id " .
                "FROM #__menu " .
                "WHERE id = '{$jsmfConfig->itemid}' " .
                "LIMIT 1";
            $database->setQuery($query);
//            jsmf_showResult($database->query(), $database->getQuery());
            $result = $database->loadResult();
            if (empty($result)) {
                //finally update if possible
                $query =
                    "UPDATE #__menu " .
                    "SET id = '{$jsmfConfig->itemid}' " .
                    "WHERE link='index.php?option=com_smf'";
                $database->setQuery($query);
                $jsmf_install_out .= jsmf_showResult($database->query(), $database->getQuery());
                $menu_id = $jsmfConfig->itemid;
            } /*else {
            	//otherwise set itemid to the current
                $jsmfConfig->itemid = $menu_id;
            }*/
        } /*else {
            $jsmfConfig->itemid = $menu_id;
        }*/
        //call saveParams and be done

//        if ($jsmfAdmin->saveParams($jsmfConfig)) {
//            //we were able to save the params, so there is no need to create new
//            $create_new = FALSE;
//        }
        unset($jsmfConfig);
    }
//    if ($create_new) {
        $query =
            "DROP TABLE IF EXISTS #__jsmf_config";
        $database->setQuery($query);
        $jsmf_install_out .= jsmf_showResult($database->query(), $database->getQuery());

        //create a new table then!
        $query =
            "CREATE TABLE #__jsmf_config " .
            "(id int(10) unsigned NOT NULL auto_increment, " .
            "config text NOT NULL default '', " .
            "PRIMARY KEY  (`id`) " .
            ") TYPE=MyISAM";
        $database->setQuery($query);
        $jsmf_install_out .= jsmf_showResult($database->query(), $database->getQuery());

        //populate it too!
        $query =
            "INSERT INTO #__jsmf_config ".
            "( id, config ) " .
            "VALUES ( 1, 'url=|smf_path=|login_redirect=0|logout_redirect=0|" .
            "smf_prefix=smf_|wrapped=1|sync_uname=0|hide_email=0|" .
            "cb_profile=0|reg_module=joomla|login_module=mod_login|debug=0|" .
            "jm_from=15|jm_sticky=1|jm_empty=1|jm_topics=1|pathway=1|pagetitles=1|" .
            "css=1|description=1|def_keywords=0|keywords=1|pms=smf|" .
            "option=com_smf|itemid=$menu_id|code=$code|" .
            "cache_user_array=0|use_function_cache=1|" .
            "announce_url=http://www.joomlahacks.com/news/mh_announcement.rdf|" .
            "news_url=http://www.joomlahacks.com/index2.php?option=com_rss&amp;feed=RSS1.0&amp;no_html=ss1|" .
            "version_url=http://www.joomlahacks.com/news/mh_mambo_smf_update.rdf|" .
            "help_url=http://www.joomlahacks.com/news/mh_mambo_smf_help.rdf|" .
            "help_link=http://www.joomlahacks.com/component/option,com_smf/Itemid,94/|help_boardid=47|" .
            "last_modified=".time()."' )";
        $database->setQuery($query);
        $jsmf_install_out .= jsmf_showResult($database->query(), $database->getQuery());
//    }

    //at this point the correct params should be in the table, try to load them
    //$jsmfConfig = $jsmfAdmin->loadParams(TRUE);


//        <queries>
//            <query>
//                DROP TABLE IF EXISTS `#__jsmf_config`;
//            </query>
//            <query>
//                CREATE TABLE `#__jsmf_config` (
//                  `id` int(10) unsigned NOT NULL auto_increment,
//                  `config` text NOT NULL default '',
//                  PRIMARY KEY  (`id`)
//                ) TYPE=MyISAM;
//            </query>
//        </queries>



//    $query =
//        "INSERT INTO #__jsmf_config ".
//        "( id, config ) " .
//        "VALUES ( 1, 'url=|smf_path=|login_redirect=0|logout_redirect=0|smf_prefix=smf_|wrapped=1|sync_uname=0|hide_email=0|" .
//        "cb_profile=0|reg_module=joomla|login_module=mod_login|debug=0|jm_from=15|jm_sticky=1|pathway=1|pagetitles=1|pms=smf|" .
//        "option=com_smf|itemid=|code=|announce_url=http://www.joomlahacks.com/news/mh_announcement.rdf|" .
//        "news_url=http://www.joomlahacks.com/index2.php?option=com_rss&amp;feed=RSS1.0&amp;no_html=ss1|" .
//        "version_url=http://www.joomlahacks.com/news/mh_mambo_smf_update.rdf|" .
//        "help_url=http://www.joomlahacks.com/news/mh_mambo_smf_help.rdf|last_modified=".time()."' )";
//    $database->setQuery($query);
//    jsmf_showResult($database->query(), $database->getQuery());


    //1.1.4.1-3 Update the menu link to reference the correct component id
//    $database->setQuery("SELECT id from #__components WHERE link='option=com_smf'");
//    $component_id = $database->loadResult();
    //get the current component id
    $query =
        "SELECT id " .
        "FROM #__components " .
        "WHERE link='option=com_smf'";
    $database->setQuery($query);
    $component_id = $database->loadResult();

    $query =
        "UPDATE #__menu " .
        "SET componentid={$component_id} " .
        "WHERE link='index.php?option=com_smf'";

    $database->setQuery($query);
    $jsmf_install_out .= jsmf_showResult($database->query(), $database->getQuery());

//    if (strcmp($_VERSION->PRODUCT, 'Joomla!') == 0) {
//        @chmod(JPATH_BASE . '/mambots/system', 0777 );
//        rename(JSMFADMIN_BASE . '/bots/jsmf_ssi_include.php', JPATH_BASE . '/mambots/system/jsmf_ssi_include.php');
//        rename(JSMFADMIN_BASE . '/bots/jsmf_ssi_include.x', JPATH_BASE. '/mambots/system/jsmf_ssi_include.xml');
//
//        $query =
//            "INSERT INTO #__mambots " .
//            "(id, name, element, folder, access, ordering, published, iscore, client_id, checked_out, checked_out_time, params) " .
//            "VALUES ('', 'jsmf_ssi_include', 'jsmf_ssi_include', 'system', 0, 0, 1, 0, 0, 0, '0000-00-00 00:00:00', '');";
//        $database->setQuery($query);
//        jsmf_showResult($database->query(), $database->getQuery());
//    }




/*        <tr>
            <td>
                <code>Installation: <font color="green"><b>SUCCESSFUL</b></font></code>
            </td>
        </tr>
    </table>*/
    /* Show installation result to user */
    $jsmf_install_out .= '
    </div>
    <div align="left">
        <code>Installation: <font color="green"><b>SUCCESSFUL</b></font></code>
    </div>
    <div>
        <br />Continue to the <a href="'.$mosConfig_live_site.'/administrator/index2.php?option=com_smf&amp;task=install" title="JSMF Install Page"><u><b>JSMF Install Page</b></u></a> to complete the installation.
    </div>';
    return $jsmf_install_out;
}

/**
 * Format and display query results to the user
 *
 *
 * @param boolean $result
 * @param string $query Query
 * @return n/a
 */
function jsmf_showResult($result, $query)
{

    if ($result) {
		$color = 'green';
        $message = 'Successful';
	} else {
		$color = 'red';
        $message = 'failed ('. $query.')';
	}
/*    return '
        <tr>
            <td>
            <code>Query: <font color="'.$color.'">'.$message.'</font></code>
            </td>
        </tr>';*/
    return '<br /><code>Query: <font color="'.$color.'">'.$message.'</font></code>';

}
?>