<?php
/* tabstop=4 tabreplace=space */
/**
 * Joomla-SMF Who's Online
 *
 * This file is the Joomla-SMF who's online module which displays online users,
 * links to the SMF or pms chat system, flashchat users, and general user count
 * statistics.
 *
 * LICENSE: This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 * @category    Module
 * @package     mod_smf_whosonline
 * @author      Cowboy <ross@joomlahacks.com>
 * @author      Wolverine <joshualross@gmail.com>
 * @copyright   (C) JoomlaHacks.com. All rights reserved.
 * @license     http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @version     $Id: mod_smf_whosonline.php 34 2006-09-09 15:51:56Z joshualross $
 * @revision    $LastChangedRevision: 34 $
 * @date        $LastChangedDate: 2006-09-09 11:51:56 -0400 (Sat, 09 Sep 2006) $
 * @file        $HeadURL: http://scm.joomla.org/svn/repos/joomla-smf_whos_online/mod_smf_whosonline.php $
 * @link        http://www.JoomlaHacks.com
 * @since       File available since Release 2.0
 *
 * Visit JoomlaHacks.com for more Joomla Hacks!
 */

/** ensure this file is being included by a parent file */
defined( '_VALID_MOS' ) or die( 'Restricted Access.' );
//mosConfig_live_site used for images
//1.1.1 added mosConfig_live_site to the globals (-Wolverine)
global $mosConfig_live_site, $mosConfig_absolute_path, $database;
global $profilelink, $displayrealname, $displaygroupcolor, $liststyle, $pmlink;

//2.0 first, get the class object, then use it to load the params
$jsmf =& jsmfFrontend::singleton();
$jsmfConfig = $jsmf->loadParams();

//1.2 Set defaults for all parameters (-Wolverine)
$showmode           = $params->get( 'showmode', '' );
$moduleclass_sfx    = $params->get( 'moduleclass_sfx', '' );
$displayrealname    = $params->get( 'displayrealname', 0 );
$displaygroupcolor  = $params->get( 'displaygroupcolor', 0 );
$liststyle          = $params->get( 'liststyle', 0 );
$showchatters       = $params->get( 'showchatters', 0 );
$profilelink        = $params->get( 'profilelink', 0 );
$pmlink             = $params->get( 'pmlink', 0 );
$flashchaturl       = $params->get( 'flashchaturl', '' );
$chatroomempty      = $params->get( 'chatroomempty', '' );




// this is largely the default method used from the Joomla Who's Online module
$content     = '';

// show online count
if ($showmode==0 || $showmode==2) {
    $query =
        "SELECT guest, usertype " .
        "FROM #__session";
    $database->setQuery( $query );
    $sessions = $database->loadObjectList();

    // calculate number of guests and members
    $user_array     = 0;
    $guest_array    = 0;
    foreach( $sessions as $session ) {
        // if guest increase guest count by 1
        if ( $session->guest == 1 && !$session->usertype ) {
            $guest_array++;
        }
        // if member increase member count by 1
        if ( $session->guest == 0 ) {
            $user_array++;
        }
    }

    // check if any guest or member is on the site
    if ($guest_array != 0 || $user_array != 0) {
        $content .= _WE_HAVE;

        // guest count handling
        if ($guest_array == 1) {
        // 1 guest only
            $content .= sprintf( _GUEST_COUNT, $guest_array );
        } else if ($guest_array > 1) {
        // more than 1 guest
            $content .= sprintf( _GUESTS_COUNT, $guest_array );
        }

        // if there are guests and members online
        if ($guest_array != 0 && $user_array != 0) {
            $content .= _AND;
        }

        // member count handling
        if ($user_array == 1) {
        // 1 member only
            $content .= sprintf( _MEMBER_COUNT, $user_array );
        } else if ($user_array > 1) {
        // more than 1 member
            $content .= sprintf( _MEMBERS_COUNT, $user_array );
        }

        $content .= _ONLINE;
    }
}

// show online member names
if ($showmode > 0) {
    $query =
        "SELECT DISTINCT a.username, a.userid, b.name " .
        "FROM #__session AS a, #__users as b " .
        "WHERE a.guest = 0 " .
        "AND b.id = a.userid " .
        "GROUP by b.id";

    $database->setQuery($query);
    $rows = $database->loadObjectList();

    if (count($rows)) {
        foreach($rows as $row) {

            $content .= getListStyle(createOnlineLink($row->username, $row->name, $row->userid));

        }
    }
}


if ($showchatters) {

    /* check if they put flashchat.php on the end or not */
    $content .= "<br/><a href=\"#\" onclick=\"javascript: window.open('http://".$flashchaturl."/flashchat.php', '', 'toolbar=no,location=no,status=no,menubar=no,scrollbars=yes,resizable=yes,width=780,height=550'); return false\"><img src=\"".$mosConfig_live_site."/modules/mod_smf_whosonline.gif\" border=\"0\" alt=\"Live Joomla Chat\"/></a><br />";

    $chatters = '';

    $query =
        "SELECT #__users.username, #__users.id, #__users.name " .
        "FROM #__users, #__fc_connections " .
        "WHERE #__fc_connections.userid = #__users.id " .
        "ORDER BY updated desc";

    $database->setQuery($query);
    if ($rows = $database->loadObjectList()) {
        //$rows = $database->loadObjectList();
        foreach($rows as $row) {
            $chatters .= getListStyle(createOnlineLink($row->username, $row->name, $row->id));
        }
    }

    if (empty($chatters)) {
        $content .= getListStyle($chatroomempty != '' ? $chatroomempty : "The chatroom is quiet...");
    } else {
        $content .= $chatters;
    }
}

//function ListStyle($item) {
/**
 * Adds optional style to link
 * @param string $link username or url link
 * @global boolean $liststyle
 * @global string $mosConfig_live_site Site URL
 */
function getListStyle($link)
{
    global $liststyle, $mosConfig_live_site;

    if ($liststyle) {
        return '<br /><img src="'.$mosConfig_live_site.'/images/M_images/arrow.png" border="0" alt="" />'.$link;
    }
    return '<ul><li><strong>'.$link.'</strong></li></ul>';
}

//This function requires that JoomlaSMF Bridge be installed(depracated)
//1.2 use $mosurl for links (-Wolverine)
//1.3 don't use $mosurl for links to allow use of other bridges(-Wolverine)
/**
 * Creates a link to given user
 * @param string $username
 * @param string $name
 * @param string $userid
 */
function createOnlineLink($username, $name, $userid) {
    global $database, $mosConfig_absolute_path, $mosConfig_sef, $mosConfig_live_site;
    global $profilelink, $displayrealname, $displaygroupcolor, $pmlink;

    $jsmf = jsmfFrontend::singleton();
    $jsmfConfig = $jsmf->loadParams();


//this all changes with JSMF 2.0, no need to store the pm or profile settings
//because the bridge will handle them
//really, the only thing we need here is the smf color of this user


    if (!$displayrealname) {
        $name = $username;
    }

    //get the member color
    $smf_uid = '';
    $smf_group = '';
    $query =
        "SELECT ID_MEMBER, ID_GROUP, ID_POST_GROUP " .
        "FROM {$jsmfConfig->smf_prefix}members " .
        "WHERE memberName = '$username' " .
        "LIMIT 1";
    $database->setQuery($query);
    $row = null;
    if ($database->loadObject($row)) {
    	$smf_uid = $row->ID_MEMBER;
        if (empty($row->ID_GROUP)) {
        	$smf_group = $row->ID_POST_GROUP;
        } else {
        	$smf_group = $row->ID_GROUP;
        }
    }
    if (!empty($smf_group)) {
        $query =
            "SELECT onlineColor " .
            "FROM {$jsmfConfig->smf_prefix}membergroups " .
            "WHERE ID_GROUP = '$smf_group'";
        $database->setQuery($query);
        $smf_color = $database->loadResult();
    }

    //profile link
    $prof_link = '';
    if($profilelink == '1')
    {
    $prof_link = $jsmf->fixLink("index.php?action=profile;u=$smf_uid");
    }
    //PMS link
    $pms_link  = $jsmf->fixLink("index.php?action=pm;sa=send;u=$smf_uid");
	$endlink = '';

    //construct the links
    if ($displaygroupcolor && !empty($smf_color) && !empty($prof_link)) {
        $endlink .= '<a href="'.$prof_link.'" style="color: '.$smf_color.';">'.$name.'</a>';
    } else if (!empty($prof_link)) {
    	$endlink .= '<a href="'.$prof_link.'">'.$name.'</a>';
    } else {
    	$endlink .= '<span>'.$name.'</span>';
    }
    if ($pmlink) {
    	$endlink .= '<a href="'.$pms_link.'"><img src="'.$mosConfig_live_site.'/images/M_images/emailButton.png" style="border:0px; height:10px;" alt="Send a PM to '.$name.'" /></a>';
    }
	return $endlink;
}

?>
